/*!
 * (C) Emu Analytics
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-df77e04f.js');
const component_utils = require('./component.utils-3bbeec87.js');
const randomId = require('./random-id-e0a21dd6.js');
const debug = require('./debug-490602eb.js');

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const FlowMapPopup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Set to `true` to enable 'close' button.
     */
    this.closeButton = true;
    /**
     * Set to `true` to close popup when map is clicked.
     */
    this.closeOnClick = false;
    /**
     * Set to `true` to close popup when map is moved.
     */
    this.closeOnMove = false;
    /** Maximum width of popup in CSS units. */
    this.maxWidth = '300px';
    /**
     *
     * Move popup when feature location changes. Specify `true` to enable
     * automatic location tracking as map feature moves or specify a
     * reactive expression returning lng/lat as a 2-element array.
     *
     * @reactive
     */
    this.trackLocation = false;
    /** Move popup to `trackLocation` immediately. */
    this.fireTrackImmediately = false;
  }
  async componentWillLoad() {
    var _a;
    if (!this.el.id) {
      this.el.setAttribute('id', (_a = this.name) !== null && _a !== void 0 ? _a : randomId.randomId('popup'));
    }
    debug.debugLifecycle(`${debug.formatEl(this.el)} will load`);
    await this.flowMap._map.initializeContext();
    /*
    if (this.el.childElementCount === 0 || this.el.firstElementChild.tagName !== 'TEMPLATE') {
      this.flowMap._map.context.emitError(
        new Error(`${formatEl(this.el)}: popup content must be specified using <template> element.`)
      );
    }*/
  }
  async componentDidLoad() {
    debug.debugLifecycle(`${debug.formatEl(this.el)} did load`);
  }
  async disconnectedCallback() {
    debug.debugLifecycle(`${debug.formatEl(this.el)} did unload`);
  }
  render() {
    return index.h(index.Host, { class: "map__popup" });
  }
  get el() { return index.getElement(this); }
};
__decorate([
  component_utils.AncestorElement({ supportAttr: false })
], FlowMapPopup.prototype, "flowMap", void 0);

exports.flow_map_popup = FlowMapPopup;
