/*!
 * (C) Emu Analytics
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const contextRegistry = require('./context-registry-2412f040.js');
const flowCoreContext = require('./flow-core-context-9645d5e4.js');
const flowCoreParameter = require('./flow-core-parameter-e1f6aeab.js');
const debug = require('./debug-490602eb.js');
require('./debounce-4ce4579a.js');
require('./index-98203e74.js');
require('./ensure-array-3a43229a.js');
require('./random-id-e0a21dd6.js');

/**
 * A global instance of [ContextRegistry].
 *
 *
 * This should be client code as the entry point to the Flo.w RDF JavaScript API.
 */
const flow = contextRegistry.globalContextRegistry;

exports.ContextRegistry = contextRegistry.ContextRegistry;
exports.DEFAULT_CONTEXT_ID = contextRegistry.DEFAULT_CONTEXT_ID;
exports.globalContextRegistry = contextRegistry.globalContextRegistry;
exports.FLOW_CONTEXT_ATTR = flowCoreContext.FLOW_CONTEXT_ATTR;
exports.FLOW_CONTEXT_TAG = flowCoreContext.FLOW_CONTEXT_TAG;
exports.FlowCoreContext = flowCoreContext.FlowCoreContext;
exports.FlowQuery = flowCoreContext.FlowQuery;
exports.StateStore = flowCoreContext.StateStore;
exports.FlowCoreDataSource = flowCoreParameter.FlowCoreDataSource;
exports.FlowCoreMap = flowCoreParameter.FlowCoreMap;
exports.FlowCoreMapCompositeLayer = flowCoreParameter.FlowCoreMapCompositeLayer;
exports.FlowCoreMapLayer = flowCoreParameter.FlowCoreMapLayer;
exports.FlowCoreMapPopup = flowCoreParameter.FlowCoreMapPopup;
exports.FlowCoreParameter = flowCoreParameter.FlowCoreParameter;
exports.escapeMaplibreString = flowCoreParameter.escapeMaplibreString;
exports.expandCircleRadius = flowCoreParameter.expandCircleRadius;
exports.expandCompositeCircleLayer = flowCoreParameter.expandCompositeCircleLayer;
exports.expandCompositeFillLayer = flowCoreParameter.expandCompositeFillLayer;
exports.expandCompositeLayer = flowCoreParameter.expandCompositeLayer;
exports.expandCompositeLayerFlowStyle = flowCoreParameter.expandCompositeLayerFlowStyle;
exports.expandCompositeLineLayer = flowCoreParameter.expandCompositeLineLayer;
exports.expandLabelSize = flowCoreParameter.expandLabelSize;
exports.expandPropertyValue = flowCoreParameter.expandPropertyValue;
exports.expandStrokeWidth = flowCoreParameter.expandStrokeWidth;
exports.isCompositeLayer = flowCoreParameter.isCompositeLayer;
exports.isDataDrivenProperty = flowCoreParameter.isDataDrivenProperty;
exports.isExpressionProperty = flowCoreParameter.isExpressionProperty;
exports.isLiteralProperty = flowCoreParameter.isLiteralProperty;
exports.isMaplibreLayer = flowCoreParameter.isMaplibreLayer;
exports.isSupportedLayerType = flowCoreParameter.isSupportedLayerType;
exports.labelLayerForCompositeLayer = flowCoreParameter.labelLayerForCompositeLayer;
exports.orderByArrayIndex = flowCoreParameter.orderByArrayIndex;
exports.flowComputed = debug.computed;
exports.flowObservable = debug.observable;
exports.flow = flow;
