import { html } from 'lit-html';

export default {
  title: 'Components|flow-value',
  component: 'flow-value',
  parameters: {
    docs: {
      inlineStories: false,
      iframeHeight: '100px'
    }
  }
};

let context;

const contextInitialized = {
  handleEvent(ev) {
    context = ev.detail;
    context.state.set('testValue', 0);
  }
};

const updateValue = {
  handleEvent(ev) {
    const newVal = Math.random() * 100;
    console.log(newVal);
    context.state.set('testValue', newVal);
  }
};

export const basic = () => html`
  <flow-context @flowContextInitialized="${contextInitialized}"></flow-context>
  <flow-button @click="${updateValue}">Update</flow-button>
  <flow-value value="$testValue" format=".1f"></flow-value>
`;
