/*!
 * (C) Emu Analytics
 */
import { Component, Host, h, Element, Prop } from '@stencil/core';
/**
 * @since 1.0
 * @status stable
 */
export class FlowListDivider {
  constructor() {
    /**
     * Set to `true` to pad the divider to align with the list text.
     */
    this.padded = false;
    /**
     * Set to `true` to inset the divider past the list text.
     */
    this.inset = false;
    /**
     * Set to display text above the divider line.
     */
    this.text = '';
  }
  componentWillLoad() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  render() {
    const classes = {
      ['mdc-list-divider']: true,
      ['mdc-list-divider--padded']: this.padded,
      ['mdc-list-divider--inset']: this.inset,
      ['mdc-list-divider--with-text']: !!this.text
    };
    return h(Host, { class: classes }, this.text ? h("span", { class: "mdc-list-item__text" }, this.text) : null);
  }
  static get is() { return "flow-list-divider"; }
  static get originalStyleUrls() { return {
    "$": ["list-divider.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["list-divider.css"]
  }; }
  static get properties() { return {
    "padded": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Set to `true` to pad the divider to align with the list text."
      },
      "attribute": "padded",
      "reflect": false,
      "defaultValue": "false"
    },
    "inset": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Set to `true` to inset the divider past the list text."
      },
      "attribute": "inset",
      "reflect": false,
      "defaultValue": "false"
    },
    "text": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Set to display text above the divider line."
      },
      "attribute": "text",
      "reflect": false,
      "defaultValue": "''"
    }
  }; }
  static get elementRef() { return "el"; }
}
