/*!
 * (C) Emu Analytics
 */
import { ERRORS } from './constants';
/**
 * @internal
 */
export class EvaluationError extends Error {
  constructor(expr, errors) {
    super(EvaluationError.formatMessage(expr, errors));
    this.name = ERRORS.EvaluationError;
    this.expression = expr;
    this.errors = errors;
  }
  static formatMessage(_expr, errors) {
    return [`Failed to evaluation expression:`].concat(errors).join('\n');
  }
}
