/*!
 * (C) Emu Analytics
 */
import { ERRORS } from './constants';
/**
 * @internal
 */
export class ValidationError extends Error {
  constructor(message, source, errors) {
    super(ValidationError.formatMessage(message, source, errors));
    this.name = ERRORS.ValidationError;
    this.source = source;
    this.errors = errors;
  }
  static formatMessage(message, _source, errors) {
    return [message].concat(errors).join('\n');
  }
}
