/*!
 * (C) Emu Analytics
 */
import Debug from 'debug';
import * as mobx from 'mobx';
export const debug = Debug('flow:debug');
export const debugContext = Debug('flow:context');
export const debugLifecycle = Debug('flow:lifecycle');
export const debugMapStyle = Debug('flow:map-style');
export const debugPalette = Debug('flow:palette');
export const debugQuery = Debug('flow:query');
export const debugDataJoin = Debug('flow:datajoin');
const PrintStateCSS = 'padding: 2px 4px; border-radius: 2px; background: #389DFF; color: white;';
export function printState(path, context) {
  const value = mobx.toJS(context.state.get(path), { recurseEverything: false });
  console.log(`%cstate.${path}`, PrintStateCSS, value);
}
export function formatEl(el) {
  if (!el) {
    return '<??>';
  }
  return `<${el.localName} id="${el.id || '??'}">`;
}
