/*!
 * (C) Emu Analytics
 */
const durationRegex = /(-?\d*\.?\d+(?:e[-+]?\d+)?)\s*([a-zμ]*)/ig;
export function parse(str) {
  let millis = 0;
  let unit;
  let duration;
  // ignore commas
  str = str.replace(/(\d),(\d)/g, '$1$2');
  str.replace(durationRegex, (_, n, u) => {
    duration = parseFloat(n);
    unit = u.toLowerCase().replace(/s$/, '');
    const unitMultiplier = parse[unit];
    if (unitMultiplier) {
      millis += duration * unitMultiplier;
    }
    else {
      millis = undefined;
      unit = undefined;
    }
    return '';
  });
  return {
    millis,
    unit,
    duration
  };
}
parse.millis =
  parse.millisecond =
    parse.ms = 1;
parse.second =
  parse.sec =
    parse.s = parse.ms * 1000;
parse.minute =
  parse.min =
    parse.m = parse.s * 60;
parse.hour =
  parse.hr =
    parse.h = parse.m * 60;
parse.day =
  parse.d = parse.h * 24;
parse.week =
  parse.wk =
    parse.w = parse.d * 7;
parse.M =
  parse.month = parse.d * (365.25 / 12);
parse.year =
  parse.yr =
    parse.y = parse.d * 365.25;
