/*!
 * (C) Emu Analytics
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { r as removeUndefined, g as globalContextRegistry } from './context-registry.js';

const FlowContext$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.flowContextInitialized = createEvent(this, "flowContextInitialized", 7);
    /**
     * The Flo.w context ID. Specify to use multiple contexts.
     */
    this.contextId = 'default';
  }
  componentWillLoad() {
    const config = removeUndefined({
      id: this.contextId,
      apiKey: this.apiKey,
      host: this.host
    });
    this.context = globalContextRegistry.initializeContext(config);
    this.flowContextInitialized.emit(this.context);
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
}, [1, "flow-context", {
    "apiKey": [1, "api-key"],
    "context": [16],
    "contextId": [1, "context-id"],
    "host": [1]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["flow-context"];
  components.forEach(tagName => { switch (tagName) {
    case "flow-context":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, FlowContext$1);
      }
      break;
  } });
}

const FlowContext = FlowContext$1;
const defineCustomElement = defineCustomElement$1;

export { FlowContext, defineCustomElement };
