/*!
 * (C) Emu Analytics
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';

const DataColumn = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.flowChange = createEvent(this, "flowChange", 7);
    /**
     * The column alignment.
     */
    this.align = 'left';
    /**
     * Set to `true` to enable column sorting controls.
     */
    this.sortable = false;
    /**
     * The column width (with CSS units).
     */
    this.width = null;
    /**
     * Set to `true` to allow HTML content in the column.
     */
    this.allowHtml = false;
  }
  connectedCallback() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  emitChange() {
    this.flowChange.emit();
  }
  render() {
    return h(Host, null);
  }
  static get watchers() { return {
    "name": ["emitChange"],
    "property": ["emitChange"],
    "align": ["emitChange"],
    "sortable": ["emitChange"],
    "format": ["emitChange"],
    "width": ["emitChange"]
  }; }
}, [0, "flow-data-column", {
    "name": [513],
    "property": [513],
    "align": [513],
    "sortable": [516],
    "format": [513],
    "width": [1],
    "allowHtml": [4, "allow-html"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["flow-data-column"];
  components.forEach(tagName => { switch (tagName) {
    case "flow-data-column":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, DataColumn);
      }
      break;
  } });
}

const FlowDataColumn = DataColumn;
const defineCustomElement = defineCustomElement$1;

export { FlowDataColumn, defineCustomElement };
