/*!
 * (C) Emu Analytics
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const listDividerCss = ":host{position:relative;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}flow-list-divider{display:block}flow-list-divider.mdc-list-divider{border-bottom-color:var(--flow-color-step-100)}flow-list-item .mdc-list-item__secondary-text{color:var(--flow-color-step-500)}.mdc-list-divider.mdc-list-divider--with-text{display:flex;height:48px;padding:0 16px;align-items:center;overflow:hidden;font-weight:bold}.mdc-list-divider.mdc-list-divider--with-text.mdc-list-divider--padded,.mdc-list-divider.mdc-list-divider--with-text.mdc-list-divider--inset{padding:0}";

const FlowListDivider$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    /**
     * Set to `true` to pad the divider to align with the list text.
     */
    this.padded = false;
    /**
     * Set to `true` to inset the divider past the list text.
     */
    this.inset = false;
    /**
     * Set to display text above the divider line.
     */
    this.text = '';
  }
  componentWillLoad() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  render() {
    const classes = {
      ['mdc-list-divider']: true,
      ['mdc-list-divider--padded']: this.padded,
      ['mdc-list-divider--inset']: this.inset,
      ['mdc-list-divider--with-text']: !!this.text
    };
    return h(Host, { class: classes }, this.text ? h("span", { class: "mdc-list-item__text" }, this.text) : null);
  }
  get el() { return this; }
  static get style() { return listDividerCss; }
}, [0, "flow-list-divider", {
    "padded": [4],
    "inset": [4],
    "text": [1]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["flow-list-divider"];
  components.forEach(tagName => { switch (tagName) {
    case "flow-list-divider":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, FlowListDivider$1);
      }
      break;
  } });
}

const FlowListDivider = FlowListDivider$1;
const defineCustomElement = defineCustomElement$1;

export { FlowListDivider, defineCustomElement };
