/*!
 * (C) Emu Analytics
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { A as AncestorElement } from './component.utils.js';
import { r as randomId } from './random-id.js';
import { d as debugLifecycle, f as formatEl } from './debug.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const FlowMapPopup$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    /**
     * Set to `true` to enable 'close' button.
     */
    this.closeButton = true;
    /**
     * Set to `true` to close popup when map is clicked.
     */
    this.closeOnClick = false;
    /**
     * Set to `true` to close popup when map is moved.
     */
    this.closeOnMove = false;
    /** Maximum width of popup in CSS units. */
    this.maxWidth = '300px';
    /**
     *
     * Move popup when feature location changes. Specify `true` to enable
     * automatic location tracking as map feature moves or specify a
     * reactive expression returning lng/lat as a 2-element array.
     *
     * @reactive
     */
    this.trackLocation = false;
    /** Move popup to `trackLocation` immediately. */
    this.fireTrackImmediately = false;
  }
  async componentWillLoad() {
    var _a;
    if (!this.el.id) {
      this.el.setAttribute('id', (_a = this.name) !== null && _a !== void 0 ? _a : randomId('popup'));
    }
    debugLifecycle(`${formatEl(this.el)} will load`);
    await this.flowMap._map.initializeContext();
    /*
    if (this.el.childElementCount === 0 || this.el.firstElementChild.tagName !== 'TEMPLATE') {
      this.flowMap._map.context.emitError(
        new Error(`${formatEl(this.el)}: popup content must be specified using <template> element.`)
      );
    }*/
  }
  async componentDidLoad() {
    debugLifecycle(`${formatEl(this.el)} did load`);
  }
  async disconnectedCallback() {
    debugLifecycle(`${formatEl(this.el)} did unload`);
  }
  render() {
    return h(Host, { class: "map__popup" });
  }
  get el() { return this; }
}, [0, "flow-map-popup", {
    "name": [1],
    "closeButton": [4, "close-button"],
    "closeOnClick": [4, "close-on-click"],
    "closeOnMove": [4, "close-on-move"],
    "maxWidth": [1, "max-width"],
    "trackLocation": [8, "track-location"],
    "fireTrackImmediately": [4, "fire-track-immediately"],
    "popupClass": [1, "popup-class"]
  }]);
__decorate([
  AncestorElement({ supportAttr: false })
], FlowMapPopup$1.prototype, "flowMap", void 0);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["flow-map-popup"];
  components.forEach(tagName => { switch (tagName) {
    case "flow-map-popup":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, FlowMapPopup$1);
      }
      break;
  } });
}

const FlowMapPopup = FlowMapPopup$1;
const defineCustomElement = defineCustomElement$1;

export { FlowMapPopup, defineCustomElement };
