/* FlowRdf custom elements */
export { Badge as FlowBadge } from '../types/components/badge/badge';
export { BusyOverlay as FlowBusyOverlay } from '../types/components/busy-overlay/busy-overlay';
export { Button as FlowButton } from '../types/components/button/button';
export { FlowChart as FlowChart } from '../types/components/charts/chart/chart';
export { FlowChartData as FlowChartData } from '../types/components/charts/chart-data/chart-data';
export { FlowChartSignal as FlowChartSignal } from '../types/components/charts/chart-signal/chart-signal';
export { Checkbox as FlowCheckbox } from '../types/components/checkbox/checkbox';
export { CheckboxGroup as FlowCheckboxGroup } from '../types/components/checkbox/checkbox-group';
export { Chip as FlowChip } from '../types/components/chip/chip';
export { FlowContext as FlowContext } from '../types/components/context/context';
export { DataColumn as FlowDataColumn } from '../types/components/data-tables/data-column/data-column';
export { DataTable as FlowDataTable } from '../types/components/data-tables/data-table/data-table';
export { FlowDateTimePicker as FlowDateTimePicker } from '../types/components/date-time-picker/date-time-picker';
export { FlowDialog as FlowDialog } from '../types/components/dialog/dialog';
export { FlowDrawer as FlowDrawer } from '../types/components/drawer/drawer/drawer';
export { FlowDrawerContainer as FlowDrawerContainer } from '../types/components/drawer/drawer-container/drawer-container';
export { FlowFabButton as FlowFab } from '../types/components/fabs/fab/fab';
export { FabGroup as FlowFabGroup } from '../types/components/fabs/fab-group/fab-group';
export { FlowGauge as FlowGauge } from '../types/components/gauge/gauge';
export { FlowIcon as FlowIcon } from '../types/components/icon/icon';
export { TextInput as FlowInput } from '../types/components/input/input';
export { FlowList as FlowList } from '../types/components/lists/list/list';
export { FlowListDivider as FlowListDivider } from '../types/components/lists/list-divider/list-divider';
export { FlowListGroup as FlowListGroup } from '../types/components/lists/list-group/list-group';
export { FlowListHeader as FlowListHeader } from '../types/components/lists/list-header/list-header';
export { FlowListItem as FlowListItem } from '../types/components/lists/list-item/list-item';
export { FlowMap as FlowMap } from '../types/components/maps/map/map';
export { FlowMapDataJoin as FlowMapDataJoin } from '../types/components/maps/map-data-join/map-data-join';
export { FlowMapDataSource as FlowMapDataSource } from '../types/components/maps/map-data-source/map-data-source';
export { MapIcon as FlowMapIcon } from '../types/components/maps/map-icon/map-icon';
export { FlowMapLayer as FlowMapLayer } from '../types/components/maps/map-layer/map-layer';
export { FlowMapParameter as FlowMapParameter } from '../types/components/maps/map-parameter/map-parameter';
export { FlowMapPopup as FlowMapPopup } from '../types/components/maps/map-popup/map-popup';
export { FlowProgressBar as FlowProgressBar } from '../types/components/progress-bar/progress-bar';
export { ProgressRing as FlowProgressRing } from '../types/components/progress-ring/progress-ring';
export { Radio as FlowRadio } from '../types/components/radio/radio';
export { RadioGroup as FlowRadioGroup } from '../types/components/radio/radio-group';
export { Tab as FlowTab } from '../types/components/tabs/tab/tab.component';
export { TabGroup as FlowTabGroup } from '../types/components/tabs/tab-group/tab-group.component';
export { TabPanel as FlowTabPanel } from '../types/components/tabs/tab-panel/tab-panel.component';
export { FlowTimer as FlowTimer } from '../types/components/timer/timer';
export { Tooltip as FlowTooltip } from '../types/components/tooltip/tooltip';
export { FlowValue as FlowValue } from '../types/components/data-value/data-value';

/**
 * Used to manually set the base path where assets can be found.
 * If the script is used as "module", it's recommended to use "import.meta.url",
 * such as "setAssetPath(import.meta.url)". Other options include
 * "setAssetPath(document.currentScript.src)", or using a bundler's replace plugin to
 * dynamically set the path at build time, such as "setAssetPath(process.env.ASSET_PATH)".
 * But do note that this configuration depends on how your script is bundled, or lack of
 * bundling, and where your assets can be loaded from. Additionally custom bundling
 * will have to ensure the static assets are copied to its build directory.
 */
export declare const setAssetPath: (path: string) => void;

export interface SetPlatformOptions {
  raf?: (c: FrameRequestCallback) => number;
  ael?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
  rel?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
}
export declare const setPlatformOptions: (opts: SetPlatformOptions) => void;
export * from '../types';
