/*!
 * (C) Emu Analytics
 */
export { setAssetPath, setPlatformOptions } from '@stencil/core/internal/client';
import { g as globalContextRegistry, F as FlowCoreContext } from './context-registry.js';
export { C as ContextRegistry, D as DEFAULT_CONTEXT_ID, c as FLOW_CONTEXT_ATTR, b as FLOW_CONTEXT_TAG, F as FlowCoreContext, a as FlowQuery, S as StateStore, g as globalContextRegistry } from './context-registry.js';
export { FlowBadge, defineCustomElement as defineCustomElementFlowBadge } from './flow-badge.js';
export { FlowBusyOverlay, defineCustomElement as defineCustomElementFlowBusyOverlay } from './flow-busy-overlay.js';
export { FlowButton, defineCustomElement as defineCustomElementFlowButton } from './flow-button.js';
export { FlowChart, defineCustomElement as defineCustomElementFlowChart } from './flow-chart.js';
export { FlowChartData, defineCustomElement as defineCustomElementFlowChartData } from './flow-chart-data.js';
export { FlowChartSignal, defineCustomElement as defineCustomElementFlowChartSignal } from './flow-chart-signal.js';
export { FlowCheckbox, defineCustomElement as defineCustomElementFlowCheckbox } from './flow-checkbox.js';
export { FlowCheckboxGroup, defineCustomElement as defineCustomElementFlowCheckboxGroup } from './flow-checkbox-group.js';
export { FlowChip, defineCustomElement as defineCustomElementFlowChip } from './flow-chip.js';
export { FlowContext, defineCustomElement as defineCustomElementFlowContext } from './flow-context.js';
export { FlowDataColumn, defineCustomElement as defineCustomElementFlowDataColumn } from './flow-data-column.js';
export { FlowDataTable, defineCustomElement as defineCustomElementFlowDataTable } from './flow-data-table.js';
export { FlowDateTimePicker, defineCustomElement as defineCustomElementFlowDateTimePicker } from './flow-date-time-picker.js';
export { FlowDialog, defineCustomElement as defineCustomElementFlowDialog } from './flow-dialog.js';
export { FlowDrawer, defineCustomElement as defineCustomElementFlowDrawer } from './flow-drawer.js';
export { FlowDrawerContainer, defineCustomElement as defineCustomElementFlowDrawerContainer } from './flow-drawer-container.js';
export { FlowFab, defineCustomElement as defineCustomElementFlowFab } from './flow-fab.js';
export { FlowFabGroup, defineCustomElement as defineCustomElementFlowFabGroup } from './flow-fab-group.js';
export { FlowGauge, defineCustomElement as defineCustomElementFlowGauge } from './flow-gauge.js';
export { FlowIcon, defineCustomElement as defineCustomElementFlowIcon } from './flow-icon.js';
export { FlowInput, defineCustomElement as defineCustomElementFlowInput } from './flow-input.js';
export { FlowList, defineCustomElement as defineCustomElementFlowList } from './flow-list.js';
export { FlowListDivider, defineCustomElement as defineCustomElementFlowListDivider } from './flow-list-divider.js';
export { FlowListGroup, defineCustomElement as defineCustomElementFlowListGroup } from './flow-list-group.js';
export { FlowListHeader, defineCustomElement as defineCustomElementFlowListHeader } from './flow-list-header.js';
export { FlowListItem, defineCustomElement as defineCustomElementFlowListItem } from './flow-list-item.js';
export { F as FlowCoreMap, a as FlowCoreMapPopup, FlowMap, defineCustomElement as defineCustomElementFlowMap } from './flow-map.js';
export { FlowMapDataJoin, defineCustomElement as defineCustomElementFlowMapDataJoin } from './flow-map-data-join.js';
export { FlowMapDataSource, defineCustomElement as defineCustomElementFlowMapDataSource } from './flow-map-data-source.js';
export { FlowMapIcon, defineCustomElement as defineCustomElementFlowMapIcon } from './flow-map-icon.js';
export { FlowMapLayer, defineCustomElement as defineCustomElementFlowMapLayer } from './flow-map-layer.js';
export { F as FlowCoreParameter, FlowMapParameter, defineCustomElement as defineCustomElementFlowMapParameter } from './flow-map-parameter.js';
export { FlowMapPopup, defineCustomElement as defineCustomElementFlowMapPopup } from './flow-map-popup.js';
export { FlowProgressBar, defineCustomElement as defineCustomElementFlowProgressBar } from './flow-progress-bar.js';
export { FlowProgressRing, defineCustomElement as defineCustomElementFlowProgressRing } from './flow-progress-ring.js';
export { FlowRadio, defineCustomElement as defineCustomElementFlowRadio } from './flow-radio.js';
export { FlowRadioGroup, defineCustomElement as defineCustomElementFlowRadioGroup } from './flow-radio-group.js';
export { FlowTab, defineCustomElement as defineCustomElementFlowTab } from './flow-tab.js';
export { FlowTabGroup, defineCustomElement as defineCustomElementFlowTabGroup } from './flow-tab-group.js';
export { FlowTabPanel, defineCustomElement as defineCustomElementFlowTabPanel } from './flow-tab-panel.js';
export { FlowTimer, defineCustomElement as defineCustomElementFlowTimer } from './flow-timer.js';
export { FlowTooltip, defineCustomElement as defineCustomElementFlowTooltip } from './flow-tooltip.js';
export { FlowValue, defineCustomElement as defineCustomElementFlowValue } from './flow-value.js';
export { F as FlowCoreMapCompositeLayer, r as FlowCoreMapLayer, k as escapeMaplibreString, o as expandCircleRadius, a as expandCompositeCircleLayer, b as expandCompositeFillLayer, e as expandCompositeLayer, d as expandCompositeLayerFlowStyle, c as expandCompositeLineLayer, n as expandLabelSize, f as expandPropertyValue, m as expandStrokeWidth, q as isCompositeLayer, h as isDataDrivenProperty, g as isExpressionProperty, i as isLiteralProperty, s as isMaplibreLayer, j as isSupportedLayerType, l as labelLayerForCompositeLayer, p as orderByArrayIndex } from './flow-core-map-composite-layer.js';
export { F as FlowCoreDataSource } from './flow-core-data-source.js';
export { c as flowComputed, o as flowObservable } from './debug.js';

/**
 * A global instance of [ContextRegistry].
 *
 *
 * This should be client code as the entry point to the Flo.w RDF JavaScript API.
 */
const flow = globalContextRegistry;

const version = "3.1.53";

function globalInit() {
  console.log(`Flo.w RDF initialized (version ${version})`);
  const context = new FlowCoreContext('', '', '');
  context.state.get('abbrTime');
  context.state.compute('abbrTime', state => {
    return state.time + 'f';
  });
}

const globalScripts = globalInit;

globalScripts();

export { flow };
