/*!
 * (C) Emu Analytics
 */
import { r as registerInstance, f as createEvent, h, e as Host } from './index-abc3ebe6.js';
import './public-api-4e6746fe.js';
import { r as removeUndefined } from './flow-core-context-291ff9b4.js';
import { g as globalContextRegistry } from './context-registry-d4e711d5.js';
import './flow-core-map-composite-layer-68d4484e.js';
import './debug-eda7ee1f.js';
import './parse-error-4f01ea15.js';
import './constants-34bf9e9d.js';
import './flow-core-data-source-21977c39.js';
import './index-15bb9065.js';
import './EventEmitter-1b1a10d1.js';
import './ensure-array-ffbb7493.js';
import './maplibre-spec-helper-6abb210f.js';
import './flow-core-map-4e412c37.js';
import './debounce-6de229df.js';
import './random-id-d84012dc.js';
import './flow-core-parameter-8d0890c5.js';

const FlowContext = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.flowContextInitialized = createEvent(this, "flowContextInitialized", 7);
    /**
     * The Flo.w context ID. Specify to use multiple contexts.
     */
    this.contextId = 'default';
  }
  componentWillLoad() {
    const config = removeUndefined({
      id: this.contextId,
      apiKey: this.apiKey,
      host: this.host
    });
    this.context = globalContextRegistry.initializeContext(config);
    this.flowContextInitialized.emit(this.context);
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
};

export { FlowContext as flow_context };
