/*!
 * (C) Emu Analytics
 */
import { r as registerInstance, f as createEvent, h, e as Host } from './index-abc3ebe6.js';

const DataColumn = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.flowChange = createEvent(this, "flowChange", 7);
    /**
     * The column alignment.
     */
    this.align = 'left';
    /**
     * Set to `true` to enable column sorting controls.
     */
    this.sortable = false;
    /**
     * The column width (with CSS units).
     */
    this.width = null;
    /**
     * Set to `true` to allow HTML content in the column.
     */
    this.allowHtml = false;
  }
  connectedCallback() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  emitChange() {
    this.flowChange.emit();
  }
  render() {
    return h(Host, null);
  }
  static get watchers() { return {
    "name": ["emitChange"],
    "property": ["emitChange"],
    "align": ["emitChange"],
    "sortable": ["emitChange"],
    "format": ["emitChange"],
    "width": ["emitChange"]
  }; }
};

export { DataColumn as flow_data_column };
