/*!
 * (C) Emu Analytics
 */
import { r as registerInstance, h, e as Host, g as getElement } from './index-abc3ebe6.js';
import { A as AncestorElement } from './component.utils-3df331de.js';
import { r as randomId } from './random-id-d84012dc.js';
import { T as debugLifecycle, U as formatEl } from './debug-eda7ee1f.js';
import { F as FlowCoreParameter } from './flow-core-parameter-8d0890c5.js';
import './parse-error-4f01ea15.js';
import './constants-34bf9e9d.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const FlowMapParameter = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Set to `true` to disable data joining if this parameter is `null`.
     */
    this.required = false;
  }
  async componentWillLoad() {
    if (!this.el.id) {
      this.el.setAttribute('id', randomId('parameter'));
    }
    debugLifecycle(`${formatEl(this.el)} will load`);
    await this.flowMap._map.initializeContext();
    this._parameter = new FlowCoreParameter(this.name, this.flowMap._map, this.required);
    this.setValue(this.value);
  }
  setValue(value) {
    if (this._parameter) {
      this._parameter.setValue(value);
    }
  }
  async componentDidLoad() {
    debugLifecycle(`${formatEl(this.el)} did load`);
  }
  async disconnectedCallback() {
    debugLifecycle(`${formatEl(this.el)} did unload`);
  }
  render() {
    return h(Host, null);
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "value": ["setValue"]
  }; }
};
__decorate([
  AncestorElement({ supportAttr: false })
], FlowMapParameter.prototype, "flowMap", void 0);

export { FlowMapParameter as flow_map_parameter };
