/*!
 * (C) Emu Analytics
 */
import { r as registerInstance, h, e as Host, g as getElement } from './index-abc3ebe6.js';
import { A as AncestorElement } from './component.utils-3df331de.js';
import { r as randomId } from './random-id-d84012dc.js';
import { T as debugLifecycle, U as formatEl } from './debug-eda7ee1f.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const FlowMapPopup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Set to `true` to enable 'close' button.
     */
    this.closeButton = true;
    /**
     * Set to `true` to close popup when map is clicked.
     */
    this.closeOnClick = false;
    /**
     * Set to `true` to close popup when map is moved.
     */
    this.closeOnMove = false;
    /** Maximum width of popup in CSS units. */
    this.maxWidth = '300px';
    /**
     *
     * Move popup when feature location changes. Specify `true` to enable
     * automatic location tracking as map feature moves or specify a
     * reactive expression returning lng/lat as a 2-element array.
     *
     * @reactive
     */
    this.trackLocation = false;
    /** Move popup to `trackLocation` immediately. */
    this.fireTrackImmediately = false;
  }
  async componentWillLoad() {
    var _a;
    if (!this.el.id) {
      this.el.setAttribute('id', (_a = this.name) !== null && _a !== void 0 ? _a : randomId('popup'));
    }
    debugLifecycle(`${formatEl(this.el)} will load`);
    await this.flowMap._map.initializeContext();
    /*
    if (this.el.childElementCount === 0 || this.el.firstElementChild.tagName !== 'TEMPLATE') {
      this.flowMap._map.context.emitError(
        new Error(`${formatEl(this.el)}: popup content must be specified using <template> element.`)
      );
    }*/
  }
  async componentDidLoad() {
    debugLifecycle(`${formatEl(this.el)} did load`);
  }
  async disconnectedCallback() {
    debugLifecycle(`${formatEl(this.el)} did unload`);
  }
  render() {
    return h(Host, { class: "map__popup" });
  }
  get el() { return getElement(this); }
};
__decorate([
  AncestorElement({ supportAttr: false })
], FlowMapPopup.prototype, "flowMap", void 0);

export { FlowMapPopup as flow_map_popup };
