/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "./stencil-public-runtime";
import { PredefinedColor } from "./utils/theme";
import { FlowCoreChart } from "./core/charts/flow-core-chart";
import { FlowChartSignalChangeDetails } from "./components/charts/chart/chart";
import { FlowCoreChartData } from "./core/charts/flow-core-chart-data";
import { FlowCoreChartSignal } from "./core/charts/flow-core-chart-signal";
import { FlowCoreContext } from "./core/public-api";
import { FormatFunction, RowSelectionChangedEventDetail, SortActionEventDetail } from "./components/data-tables/types";
import { DateTimePickerChangeEventDetail } from "./components/date-time-picker/interface";
import { FlowDrawChangedEvent } from "./components/drawer/drawer-container/constants";
import { FlowListActionEventDetail } from "./components/lists/list/list";
import { FlowCoreMap, FlowMapFeatureIdentifier, FlowMapGeoJSONFeature, FlowMapLngLatLike } from "./core/flow-core-map/flow-core-map";
import { FlowMapExportOptions } from "./core/flow-core-map/map-exporter";
import { FlowCoreMapPopup, FlowCoreMapPopupOptions } from "./core/flow-core-map/flow-core-map-popup";
import { FlowCoreDataJoin } from "./core/flow-core-map/flow-core-data-join";
import { FlowCoreDataSource, SelectionPopupFn } from "./core/flow-core-map/flow-core-data-source";
import { FlowCoreMapLayerBase } from "./core/flow-core-map/flow-core-map-layer-base";
import { FlowCoreParameter } from "./core/flow-core-map/flow-core-parameter";
import { TimerChangeEventDetail } from "./components/timer/interface";
export namespace Components {
    interface FlowBadge {
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color": PredefinedColor;
        /**
          * Set to true to draw a pill-style badge with rounded corners.
         */
        "pill": boolean;
        /**
          * Set to true to make the badge pulse.
         */
        "pulse": boolean;
    }
    interface FlowBusyOverlay {
        /**
          * Set to `true` to display the busy overlay. Specify a Flo.w reactive expression or a boolean value.
          * @reactive
         */
        "busy": string;
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Set to `true` to overlay the component's parent element rather than its content.
         */
        "overlayParent": boolean;
        /**
          * The size of the progress ring.
         */
        "size": 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
    }
    interface FlowButton {
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to display a smaller-sized button with reduced margins.
         */
        "compact": boolean;
        /**
          * Set to `true` to disable interaction with the button.
         */
        "disabled": boolean;
        /**
          * Specify that the linked file should be downloaded using this filename. Only used when `href` is set.
         */
        "download": string;
        /**
          * When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`.
         */
        "href": string;
        /**
          * Set to display an icon on the button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon": string;
        /**
          * Set to `true` to display an 'icon-only' button with no button body or label. Note that the default color of an 'icon-only' button is the current text color. Use the `color` property to select a different color from the application palette.
         */
        "iconButton": boolean;
        /**
          * If set, specifies the button label text. Otherwise, the text content of the element is used as the button label text.
         */
        "label": string;
        /**
          * Set to display an 'outlined' button.
         */
        "outlined": boolean;
        /**
          * Set to display a 'solid' button.
         */
        "solid": boolean;
        /**
          * Set to 'true' to indicate that activating the button should submit the form. Ignored when `href` is set.
         */
        "submit": boolean;
        /**
          * Specify a target for opening the link. Only used when `href` is set.
         */
        "target": '_blank' | '_parent' | '_self' | '_top';
        /**
          * Set to `true` to display the icon *after* the label (to the right in LTR mode).
         */
        "trailingIcon": boolean;
    }
    interface FlowChart {
        "_chart": FlowCoreChart;
        /**
          * The registered chart specification to display.
         */
        "chartSpec": string;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * The height of the chart in pixels.
         */
        "height": number;
        /**
          * Set to enable the Vega Tooltip plugin.
         */
        "tooltip": boolean;
        /**
          * The width of the chart in pixels.
         */
        "width": number;
    }
    interface FlowChartData {
        "_chartData": FlowCoreChartData;
        /**
          * The data to bind to the chart.  A reactive expression or an array of data objects.
          * @reactive
         */
        "data": string | Array<Record<string, any>>;
        /**
          * The named chart data to bind.
         */
        "name": string;
        /**
          * The data 'x' property (optional).
         */
        "x": string;
        /**
          * The data 'y' property (optional).
         */
        "y": string;
    }
    interface FlowChartSignal {
        "_chartSignal": FlowCoreChartSignal;
        /**
          * The name of the Vega signal to bind.
         */
        "name": string;
        /**
          * The Flo.w reactive expression to bind to the signal.
          * @reactive
         */
        "value": string;
    }
    interface FlowCheckbox {
        /**
          * The checkbox position relative to its label.
         */
        "align": 'start' | 'end';
        /**
          * The checked state of the checkbox.
         */
        "checked": boolean;
        /**
          * The color of the checkbox. Colors are taken from the application palette.
         */
        "color": PredefinedColor;
        /**
          * Set to `true` to disable interaction with the checkbox.
         */
        "disabled": boolean;
        /**
          * Set to `true` to enable the indeterminate checkbox state.
         */
        "indeterminate": boolean;
        /**
          * If set, specifies the checkbox label text. Otherwise, the text content of the element is used as the label text.
         */
        "label": string;
        /**
          * The name attribute of the checkbox.
         */
        "name": string;
        /**
          * Remove focus from the checkbox.
         */
        "removeFocus": () => Promise<void>;
        /**
          * Set focus on the checkbox.
         */
        "setFocus": () => Promise<void>;
        /**
          * The value attribute of the checkbox.
         */
        "value": string;
    }
    interface FlowCheckboxGroup {
        /**
          * Set to `true` to disable interaction with the checkbox group.
         */
        "disabled": boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Set to bind a Flo.w application state property to the group. The state property is an array of `value` attributes corresponding to checked checkboxes.
          * @reactive
         */
        "selectionState": string;
        /**
          * The value attribute of the checkbox group.
         */
        "value": string[];
    }
    interface FlowChip {
        /**
          * Set to `true` to make the tag clearable.
         */
        "clearable": boolean;
        /**
          * The color of the chip. Colors are taken from the application palette.
         */
        "color": PredefinedColor;
        /**
          * Set to `true` to draw a pill-style tag with rounded edges.
         */
        "pill": boolean;
        /**
          * The chip's size.
         */
        "size": 'small' | 'medium' | 'large';
    }
    interface FlowContext {
        /**
          * The Flo.w API key for accessing the Flo.w REST API.
         */
        "apiKey": string;
        "context": FlowCoreContext;
        /**
          * The Flo.w context ID. Specify to use multiple contexts.
         */
        "contextId": string;
        /**
          * The Flo.w host URL for accessing the Flo.w REST API.
         */
        "host": string;
    }
    interface FlowDataColumn {
        /**
          * The column alignment.
         */
        "align": 'left' | 'right' | 'center';
        /**
          * Set to `true` to allow HTML content in the column.
         */
        "allowHtml": boolean;
        /**
          * Specify a data formatting string or custom format function.
         */
        "format": string | FormatFunction;
        /**
          * The name of the table column.
         */
        "name": string;
        /**
          * The data object property to display in this column.
         */
        "property": string;
        /**
          * Set to `true` to enable column sorting controls.
         */
        "sortable": boolean;
        /**
          * The column width (with CSS units).
         */
        "width": string;
    }
    interface FlowDataTable {
        /**
          * Set to `true` to display a compact table with reduced font size and padding.
         */
        "compact": boolean;
        /**
          * Set to bind data to the table. May be a Flo.w reactive expression, an array of data objects or a single data object.
          * @reactive
         */
        "data": string | object[] | object;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Set to `true` to enable full row selection (requires rowSelect).
         */
        "fullRowSelect": boolean;
        /**
          * Set to `true` to disable horizontal scrolling of table data.
         */
        "noScroll": boolean;
        /**
          * Specify a data object property to use as a row ID.
         */
        "rowId": string;
        /**
          * Set to `true` to enable row selection.
         */
        "rowSelect": boolean;
        /**
          * Specify a data object property to use as a row type. The row type can be used to style table rows based on row data.
         */
        "rowType": string;
        /**
          * Returns the selected row indexes, or row IDs if `rowId` has been set.
         */
        "selectedRows": () => Promise<string[]>;
        /**
          * Set the selected rows by index, or row ID if `rowId` has been set.
         */
        "setSelectedRows": (rowIds: string[]) => Promise<void>;
        /**
          * Set to `false` to hide the header row.
         */
        "showHeader": boolean;
        /**
          * Set to `true` to keep the header row in place when scrolling the table data.
         */
        "stickyHeader": boolean;
        /**
          * Set to `true` to allow wrapping of table cell contents.
         */
        "wrap": boolean;
    }
    interface FlowDateTimePicker {
        /**
          * Set to `true` to display a border.
         */
        "border": boolean;
        /**
          * Specify 12 or 24 hour clock format.
         */
        "clockMode": '12' | '24';
        /**
          * Close the date/time picker
         */
        "close": () => Promise<void>;
        /**
          * The accent color of the popup date/time selector. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable the date/time picker.
         */
        "disabled": boolean;
        /**
          * Set to `true` to enable seconds in the display.
         */
        "enableSeconds": boolean;
        /**
          * Set to `true` to enable fixed positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "fixed": boolean;
        /**
          * The display format for the selected date/time.
         */
        "format": string;
        "inline": boolean;
        /**
          * The maximum date/time that can be selected (ISO8601 string or Date object).
         */
        "maxDate": string | Date;
        /**
          * The minimum date/time that can be selected (ISO8601 string or Date object).
         */
        "minDate": string | Date;
        /**
          * Adjusts the step for the minute input.
         */
        "minuteIncrement": number;
        /**
          * The date/time mode.
         */
        "mode"?: 'date' | 'time' | 'datetime';
        /**
          * Open the date/time picker
         */
        "open": () => Promise<void>;
        /**
          * Set to `true` to open the date/time picker on mouse click.
         */
        "openOnClick": boolean;
        /**
          * The input placeholder.
         */
        "placeholder"?: string;
        /**
          * The position of the popup date/time selector.
         */
        "position": 'above' | 'below' | 'auto';
        /**
          * Set to `true` to enable static positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "static": boolean;
        /**
          * Set display timezone using TZ identifier (e.g. Europe/London, default is local time)
         */
        "timezone"?: string;
        /**
          * Set display mode to UTC (note that when set to `true` this overrides the `timezone` attribute)
         */
        "utc": boolean;
        /**
          * The value of the picker. ISO8601 string
         */
        "value"?: string | undefined | null;
    }
    interface FlowDialog {
        /**
          * Close the dialog.
          * @param action The dialog `action` to return in the closing/closed events.
         */
        "close": (action?: string) => Promise<void>;
        /**
          * Specifies the dialog action to emit when closing the dialog via the `escape` key. Set to the empty string to disable closing by this method.
         */
        "escapeKeyAction": string;
        /**
          * Open the dialog.
         */
        "open": () => Promise<void>;
        /**
          * Specifies the dialog action to emit when closing the dialog by clicking on the scrim. Set to the empty string to disable closing by this method.
         */
        "scrimClickAction": string;
        /**
          * Returns a promise that resolves with the dialog `action` when the dialog is closed.
         */
        "waitUntilClosed": () => Promise<string>;
    }
    interface FlowDrawer {
        /**
          * Set to `true` to open the drawer.
         */
        "open": boolean;
        /**
          * The side of the parent element to which the drawer is attached.
         */
        "position": 'start' | 'end';
        /**
          * Set to `true` to display a 'side tab', which can be used to toggle the open state of the drawer.
         */
        "sideTab": boolean;
    }
    interface FlowDrawerContainer {
        "_drawerClasses": {};
    }
    interface FlowFab {
        /**
          * Set to `true` for the FAB to act like a checkbox.
         */
        "checkbox": boolean;
        /**
          * The checked state of the FAB. Only applicable if `checkbox` is set to `true`.
         */
        "checked": boolean;
        /**
          * The color of the FAB. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to display a smaller FAB.
         */
        "compact": boolean;
        /**
          * Set to display an icon on the button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Set to add an optional label to the FAB.
         */
        "label"?: string;
        /**
          * Set to `true` to display the FAB using the 'square' style. By default, FABs are round.
         */
        "square": boolean;
        /**
          * The value attribute of the FAB. Only applicable if `checkbox` is set to `true`.
         */
        "value"?: string;
    }
    interface FlowFabGroup {
        /**
          * Specify the direction in which to expand buttons when the FAB group is opened.
         */
        "direction": 'up' | 'down' | 'left' | 'right';
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * The icon of the main FAB group button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon": string;
        /**
          * Set this attribute to `true` to force the FAB group to open. The open state will be toggled automatically when the main FAB is clicked.
         */
        "open": boolean;
        /**
          * Set to bind a Flo.w application state property to the group. The state property is an array of `value` attributes corresponding to checked FABs.
          * @reactive
         */
        "selectionState": string;
    }
    interface FlowGauge {
        /**
          * The color of the gauge value. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * The transition duration in milliseconds for the animation between numeric values. Set to zero to disable animation.
         */
        "duration": number;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * The display format of the gauge value. Use a D3 format string for numeric values. Use `"icon"` to treat `value` as an icon name.
         */
        "format"?: string;
        /**
          * The gauge heading text.
         */
        "heading"?: string;
        /**
          * Set to display an icon in the gauge heading. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * The units text to display under the gauge value.
         */
        "units"?: string;
        /**
          * The gauge value specified as a Flo.w reactive expression.
          * @reactive
         */
        "value"?: string;
    }
    interface FlowIcon {
        /**
          * Specifies the label to use for accessibility. Defaults to the icon name.
         */
        "ariaLabel": string | null;
        /**
          * The color of the gauge value. Colors are taken from the application palette. If unset, the current color will be used.
         */
        "color"?: PredefinedColor;
        /**
          * The name of a built-in icon or URL to an SVG file.
         */
        "icon"?: any;
        /**
          * If enabled, the icon will be loaded lazily when it is visible in the viewport.
         */
        "lazy": boolean;
        /**
          * The size of the icon. If not specified, the current font-size will be used.
         */
        "size"?: 'x-small' | 'small' | 'regular' | 'large' | 'x-large';
    }
    interface FlowInput {
        /**
          * The color of the control. Colors are taken from the application palette.
         */
        "color": PredefinedColor;
        /**
          * Set to `true` to disable interaction with the input control.
         */
        "disabled": boolean;
        /**
          * An icon to place before the input. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon": string;
        /**
          * The label text.
         */
        "label": string;
        /**
          * The name attribute of the native input control
         */
        "name": string;
        /**
          * Prefix text to place before the input.
         */
        "prefixText": string;
        /**
          * Suffix text to place after the input.
         */
        "suffixText": string;
        /**
          * An icon action button to place after the input. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "trailingIcon": string;
        /**
          * The style of the input control.
         */
        "type": 'filled' | 'outlined' | 'plain';
        /**
          * The value of the input control.
         */
        "value": string;
    }
    interface FlowList {
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Set to bind a Flo.w application state property to this list. Radio or check-box list changes will be reflected in state property changes and vice versa.
          * @reactive
         */
        "selectionState": string;
        /**
          * Set the selected list item by value.
          * @param val
         */
        "setSelected": (val: any | any[]) => Promise<HTMLFlowListItemElement[]>;
        /**
          * Set the selected list item by index.
          * @param index
         */
        "setSelectedIndex": (index: number | number[]) => Promise<HTMLFlowListItemElement[]>;
        /**
          * Set to `true` to enable 'single selection' mode. The list will have a single selected item displayed in a distinct style.
         */
        "singleSelection": boolean;
        /**
          * Set to `true` to support two-line list items.
         */
        "twoLine": boolean;
    }
    interface FlowListDivider {
        /**
          * Set to `true` to inset the divider past the list text.
         */
        "inset": boolean;
        /**
          * Set to `true` to pad the divider to align with the list text.
         */
        "padded": boolean;
        /**
          * Set to display text above the divider line.
         */
        "text": string;
    }
    interface FlowListGroup {
    }
    interface FlowListHeader {
        /**
          * Set to `true` to display an expand/collapse button and make the following `flow-list` collapsible.
         */
        "collapsible": boolean;
        /**
          * The color of list header text and optional icon. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to display an icon before the title of the header. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon": string;
        /**
          * Set to open or close the following `flow-list`. Only applicable if `collapsible` is `true`.
         */
        "open": boolean;
    }
    interface FlowListItem {
        /**
          * Set to `true` to indicate that this item is 'activated', that is, represents a highlighted destination.
         */
        "activated": boolean;
        /**
          * Indicate the checked state of a checkbox list item.
         */
        "checked": boolean;
        /**
          * The color of the list item. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable user interaction with the list item.
         */
        "disabled": boolean;
        /**
          * Set to display a leading icon before the item text. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon": string;
        /**
          * Specifies the first line a two-line list item.
         */
        "lineOne": string;
        /**
          * Specifies the second line a two-line list item.
         */
        "lineTwo": string;
        /**
          * Set to `true` to indicate that this item is 'selected', that is, represents a user selection of options.
         */
        "selected": boolean;
        /**
          * Set to display a trailing icon after the item text. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "trailingIcon": string;
        /**
          * Specifies the type of the list item. The default type is `"list"`, which displays option icons and item text but no controls.
         */
        "type": 'list' | 'radio' | 'checkbox';
        /**
          * Specifies the value of the list item. The value is used to identify the list item in list events, to programmatically select a list item, and to set state properties when using application state binding.
         */
        "value": any;
    }
    interface FlowMap {
        "_map": FlowCoreMap;
        /**
          * Set to `true` to activate the map busy indicator.
         */
        "busyIndicator": boolean;
        /**
          * The initial position and zoom for the map (format: `"lng,lat,zoom"`). If unset the default position and zoom from the map style will be used.
         */
        "center": string;
        "closeAllPopups": () => Promise<void>;
        /**
          * Export the map to PNG format.
          * @param options
         */
        "export": (options: FlowMapExportOptions) => Promise<string>;
        /**
          * Specify radius in pixels of area around clicked point to search for map features.
         */
        "featureClickTolerance": number;
        /**
          * Position the map canvas using fixed positioning to take up the entire window. UI elements that should appear on top of the map (sidebars, drawers, etc.) must have z-index set to 1 or higher to appear above the rendered map.
         */
        "fixedPosition": boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Returns the underlying JavaScript map object.
         */
        "getMap": () => Promise<FlowCoreMap>;
        /**
          * The base map style ID.
         */
        "mapStyle": string;
        /**
          * Open a map popup.
          * @param lngLat
          * @param options
         */
        "openPopup": (lngLat: FlowMapLngLatLike, options?: FlowCoreMapPopupOptions) => Promise<FlowCoreMapPopup>;
        /**
          * Remove feature state from a single map feature.
          * @param feature
          * @param key
         */
        "removeFeatureState": (feature: maplibregl.FeatureIdentifier | FlowMapGeoJSONFeature, key?: string) => Promise<void>;
        /**
          * Set feature state on a single map feature.
          * @param feature
          * @param state
         */
        "setFeatureState": (feature: FlowMapFeatureIdentifier | FlowMapGeoJSONFeature, state: { [key: string]: any; }) => Promise<void>;
        /**
          * Set to true to sync the map position, zoom, bearing and pitch with the browser URL.
         */
        "sync": boolean;
        /**
          * Set to true to automatically resize the map when its container is resized.
         */
        "trackResize": boolean;
        /**
          * Zoom the map by the specified increment. Use a positive increment to zoom in and a negative increment to zoom out.
          * @param increment +/- zoom level
         */
        "zoomBy": (increment: number) => Promise<void>;
    }
    interface FlowMapDataJoin {
        "_datajoin": FlowCoreDataJoin;
        /**
          * Set to `true` to clear all current feature state before applying the data join.
         */
        "clear": boolean;
        /**
          * The foreign key property of the joined data. Data will be joined to features where the foreign key equals the feature ID.
         */
        "foreignKey": string;
        /**
          * The name of the data join.
          * @deprecated Use `id` attribute instead.
         */
        "name": string;
        /**
          * Specify the source layer in the target data source to join. Applicable only for vector data sources. Defaults to 'geometry'.
         */
        "sourceLayer"?: string;
        /**
          * The data to join. Specify a reactive expression or an array of data objects.
          * @reactive
         */
        "src": string | any[];
    }
    interface FlowMapDataSource {
        "_datasource": FlowCoreDataSource;
        /**
          * Specify to override application-wide API key for this data source.
         */
        "apiKey"?: string;
        "closeAllPopups": () => Promise<void>;
        "closePopup": (featureId: string | number) => Promise<void>;
        /**
          * Set to `true` to enable clustering of data points. (For GeoJSON point data sources only)
         */
        "cluster": boolean;
        /**
          * The maximum zoom level at which clustering of data points will occur. Above this zoom level data points will not be clustered. (For GeoJSON point data sources only)
         */
        "clusterMaxZoom": number;
        /**
          * The cluster radius for clustering of data points. (For GeoJSON point data sources only)
         */
        "clusterRadius": number;
        /**
          * The feature property that uniquely identifies feature. Required for data joins.
         */
        "featureId"?: string;
        /**
          * An optional limit applied when querying data
         */
        "limit"?: number;
        /**
          * The unique name of the data source.
          * @deprecated Use `id` attribute instead.
         */
        "name": string;
        /**
          * Set to `true` to clear the selection whenever the map is clicked (empty area or a feature from another data source).
         */
        "selectionClear": boolean | 'group';
        /**
          * Set to bind selected feature properties to a Flo.w application state property. Binding is one-way. The application state property is updated automatically when map feature selection changes. Setting the application state property programmatically has no effect.
          * @reactive
         */
        "selectionFeatureState"?: string;
        /**
          * Set specify the selection group for this data source. If `selectionClear` is set to `group` then this datasource's selection will be cleared when a feature from another data source in the same selection group is clicked.
         */
        "selectionGroup": any;
        /**
          * Enable automatic feature selection support for single or multiple features.
         */
        "selectionMode"?: 'none' | 'single' | 'multi';
        /**
          * Set to automatically open a popup when a map feature from this data source is clicked. The popup can be configured by specifying the ID of a registered `<flow-map-popup>` or programmatically by specifying a function that returns a `FlowCoreMapPopupOptions` object.
         */
        "selectionPopup": string | SelectionPopupFn;
        /**
          * Set to bind selected feature IDs to a Flo.w application state property. Binding is two-way. Set the associated application state property to programmatically modify feature selection for this data source.
          * @reactive
         */
        "selectionState"?: string;
        /**
          * The vector source layer to display. Defaults to 'geometry' for vector-type data sources. Omit for GeoJSON-type data sources.
         */
        "sourceLayer"?: string;
        /**
          * The source of the data. For vector data, specify a Flo.w tile source ID or a TileJSON URL. For GeoJSON data, specify a GeoJSON URL or a reactive expression returning GeoJSON data.
          * @reactive
         */
        "src": string | GeoJSON.FeatureCollection;
        /**
          * The type of the data source.
         */
        "type": 'vector' | 'geojson' | 'raster';
    }
    interface FlowMapIcon {
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * The display height in pixels of the icon.
         */
        "height": number;
        /**
          * The unique ID of the icon.
          * @deprecated Use ID attribute instead.
         */
        "name": string;
        /**
          * The pixel density of the icon. To improve display quality on high resolution screens, map icons should be provided at 2x resolution and the default pixelDensity of 2 should be used.
         */
        "pixelDensity": number;
        /**
          * Set to `true` to allow recoloring of icon using map layer style properties.
         */
        "recolor": boolean;
        /**
          * The URL of a png or svg icon file.
         */
        "src": string;
        /**
          * The display width in pixels of the icon.
         */
        "width": number;
    }
    interface FlowMapLayer {
        "_layer": FlowCoreMapLayerBase;
        /**
          * Specify to override the default layer ordering and place this layer above the named layer.
         */
        "above": string;
        /**
          * Specify to override the default layer ordering and place this layer below the named layer.
         */
        "below": string;
        /**
          * An optional layer filter. Specified as a Flo.w reactive expression.
          * @reactive
         */
        "filter": string;
        /**
          * Set to `true` to enable hover and click actions on the map layer.
         */
        "interactive": boolean;
        /**
          * @deprecated Do not use.
         */
        "layerStyle": string;
        /**
          * The maximum zoom level for the layer. Above this level, the layer will be hidden.
         */
        "maxZoom": number;
        "metadata": any;
        /**
          * The minimum zoom level for the layer. Below this level, the layer will be hidden.
         */
        "minZoom": number;
        /**
          * The name of the layer. Layer names should be unique for a particular map.
          * @deprecated Use `id` attribute instead.
         */
        "name": string;
        /**
          * The name of the map data source to display.
         */
        "source": string;
        /**
          * The vector source layer to display. Defaults to 'geometry' for vector-type data sources. Omit for GeoJSON-type data sources.
         */
        "sourceLayer": string;
        /**
          * The layer type.
         */
        "type": string;
    }
    interface FlowMapParameter {
        "_parameter": FlowCoreParameter;
        /**
          * The parameter name.
         */
        "name": string;
        /**
          * Set to `true` to disable data joining if this parameter is `null`.
         */
        "required": boolean;
        /**
          * The parameter value. A Flo.w reactive expression.
          * @reactive
         */
        "value": string;
    }
    interface FlowMapPopup {
        /**
          * Set to `true` to enable 'close' button.
         */
        "closeButton": boolean;
        /**
          * Set to `true` to close popup when map is clicked.
         */
        "closeOnClick": boolean;
        /**
          * Set to `true` to close popup when map is moved.
         */
        "closeOnMove": boolean;
        /**
          * Move popup to `trackLocation` immediately.
         */
        "fireTrackImmediately": boolean;
        /**
          * Maximum width of popup in CSS units.
         */
        "maxWidth": string;
        /**
          * The unique popup ID.
          * @deprecated Use `id` attribute instead.
         */
        "name": string;
        /**
          * Specify a CSS class to add to the popup.
         */
        "popupClass"?: string;
        /**
          * Move popup when feature location changes. Specify `true` to enable automatic location tracking as map feature moves or specify a reactive expression returning lng/lat as a 2-element array.
          * @reactive
         */
        "trackLocation"?: string | boolean;
    }
    interface FlowProgressBar {
        /**
          * The color of the progress indicator. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to show an indeterminate progress bar.
         */
        "indeterminate": boolean;
        /**
          * Set to a value between 0 and 1 to indicate current progress.
         */
        "value": number;
    }
    interface FlowProgressRing {
        /**
          * Set to `true` to automatically show the progress indicator when progress is between 0 and 1.
         */
        "autoShow": boolean;
        /**
          * The color of the progress indicator. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to show an indeterminate circular progress indicator.
         */
        "indeterminate": boolean;
        /**
          * Specify the size of the circular progress indicator.
         */
        "size": 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
        /**
          * Set to a value between 0 and 1 to indicate current progress.
         */
        "value": number;
    }
    interface FlowRadio {
        /**
          * The radio button position relative to its label.
         */
        "align": 'start' | 'end';
        /**
          * The checked state of the radio button
         */
        "checked": boolean;
        /**
          * The color of the radio button. Colors are taken from the application palette.
         */
        "color": PredefinedColor;
        /**
          * Set to `true` to disable interaction with the checkbox.
         */
        "disabled": boolean;
        /**
          * If set, specifies the radio button label text. Otherwise, the text content of the element is used as the label text.
         */
        "label": string;
        /**
          * The name attribute of the radio button.
         */
        "name": string;
        /**
          * Remove focus from the checkbox.
         */
        "removeFocus": () => Promise<void>;
        /**
          * Set focus on the checkbox.
         */
        "setFocus": () => Promise<void>;
        /**
          * The value attribute of the radio button.
         */
        "value": string;
    }
    interface FlowRadioGroup {
        /**
          * Set to `true` to disable interaction with the radio button group.
         */
        "disabled": boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Set to bind a Flo.w application state property to this list. The state property value reflects the value of the selected radio button.
          * @reactive
         */
        "selectionState": string;
        /**
          * The value attribute of the radio button group.
         */
        "value": string;
    }
    interface FlowTab {
        /**
          * Set to true to draw the tab in an active state.
         */
        "active": boolean;
        /**
          * Set to true to draw the tab in a disabled state.
         */
        "disabled": boolean;
        /**
          * The name of the tab panel the tab will control. The panel must be located in the same tab group.
         */
        "panel": string;
        /**
          * Remove focus from the tab.
         */
        "removeFocus": () => Promise<void>;
        /**
          * Set focus to the tab.
         */
        "setFocus": () => Promise<void>;
    }
    interface FlowTabGroup {
        /**
          * The placement of the tab navigation buttons.
         */
        "placement": 'top' | 'bottom' | 'left' | 'right';
        /**
          * Show the specified tab panel.
         */
        "show": (panel: string) => Promise<void>;
    }
    interface FlowTabPanel {
        /**
          * Set to `true` to show the tab panel.
         */
        "active": boolean;
        /**
          * The tab panel's name.
         */
        "name": string;
    }
    interface FlowTimer {
        /**
          * Set to `true` to disable interaction with the timer.
         */
        "disabled": boolean;
        /**
          * Set to enable/disable the play button.
         */
        "enablePlay": boolean;
        /**
          * Set to `true` to enable fixed positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "fixed": boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * The time interval for the major step buttons.
         */
        "majorStep": string;
        /**
          * The time interval for the minor step buttons.
         */
        "minorStep": string;
        /**
          * The position of the popup date/time selectors relative to the timer control.
         */
        "position": 'above' | 'below' | 'auto';
        /**
          * Set to start/stop the timer. Read to retrieve the current running state.
         */
        "running": boolean;
        /**
          * Set to `true` to enable static positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "static": boolean;
        /**
          * The Flo.w state property to bind to the timer. The state property will be synchronized with the value of the timer.
          * @reactive
         */
        "timerState"?: string;
        /**
          * Specifies the format of the Flo.w state property bound to the timer.
         */
        "timerStateFormat": 'iso' | 'millis';
        /**
          * Set display timezone using TZ identifier (e.g. Europe/London, default is local time)
         */
        "timezone"?: string;
        /**
          * Set to delay scheduled updates when the timer is running. This can be used to allow time for data to arrive in real-time use cases.
         */
        "updateDelay": string;
        /**
          * Specifies the frequency at which the timer emits updates when running. All emitted values are also rounded down using this interval. This guarantees that emitted values are always aligned to the interval specified.
         */
        "updateInterval": string;
        /**
          * Set display mode to UTC (note that setting this to `true` overrides the `timezone` attribute)
         */
        "utc": boolean;
        /**
          * Set to update the current date/time. Read to retrieve the current date/time.
         */
        "value"?: string;
    }
    interface FlowTooltip {
        /**
          * Set to `true` to disable triggering of the tooltip.
         */
        "disabled": boolean;
        /**
          * Specify the target element ID of the tooltip. This is an alternative to wrapping the target element with the tooltip.
         */
        "for": string;
        /**
          * Hide the tooltip.
         */
        "hide": () => Promise<void>;
        /**
          * The distance in pixels from which to offset the tooltip away from its target.
         */
        "offset": number;
        /**
          * Set to `true` to force the tooltip to display.
         */
        "open": boolean;
        /**
          * The preferred placement of the tooltip. Note that the actual placement may vary as needed to keep the tooltip inside of the viewport.
         */
        "position": | 'top'
    | 'top-start'
    | 'top-end'
    | 'right'
    | 'right-start'
    | 'right-end'
    | 'bottom'
    | 'bottom-start'
    | 'bottom-end'
    | 'left'
    | 'left-start'
    | 'left-end';
        /**
          * Show the tooltip.
         */
        "show": () => Promise<void>;
        /**
          * The tooltip text.
         */
        "tipText": string;
        /**
          * Controls how the tooltip is activated. Possible options include `click`, `hover`, `focus`, and `manual`. Multiple options can be passed by separating them with a space. When manual is used, the tooltip must be activated programmatically.
         */
        "trigger": string;
    }
    interface FlowValue {
        /**
          * Specifies the transition duration in milliseconds for the animation between numeric values. Set to zero to disable animation.
         */
        "duration": number;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext": string;
        /**
          * Specifies the display format. Use a D3 format string for numeric values. Use `"icon"` to treat `value` as an icon name.
         */
        "format": string;
        /**
          * Specifies the value to display as a Flo.w reactive expression.
          * @reactive
         */
        "value": string;
    }
}
export interface FlowChartCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowChartElement;
}
export interface FlowCheckboxCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowCheckboxElement;
}
export interface FlowCheckboxGroupCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowCheckboxGroupElement;
}
export interface FlowChipCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowChipElement;
}
export interface FlowContextCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowContextElement;
}
export interface FlowDataColumnCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDataColumnElement;
}
export interface FlowDataTableCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDataTableElement;
}
export interface FlowDateTimePickerCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDateTimePickerElement;
}
export interface FlowDialogCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDialogElement;
}
export interface FlowDrawerCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDrawerElement;
}
export interface FlowDrawerContainerCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowDrawerContainerElement;
}
export interface FlowInputCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowInputElement;
}
export interface FlowListCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowListElement;
}
export interface FlowMapCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowMapElement;
}
export interface FlowRadioCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowRadioElement;
}
export interface FlowRadioGroupCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowRadioGroupElement;
}
export interface FlowTabGroupCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowTabGroupElement;
}
export interface FlowTimerCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowTimerElement;
}
export interface FlowValueCustomEvent<T> extends CustomEvent<T> {
    detail: T;
    target: HTMLFlowValueElement;
}
declare global {
    interface HTMLFlowBadgeElement extends Components.FlowBadge, HTMLStencilElement {
    }
    var HTMLFlowBadgeElement: {
        prototype: HTMLFlowBadgeElement;
        new (): HTMLFlowBadgeElement;
    };
    interface HTMLFlowBusyOverlayElement extends Components.FlowBusyOverlay, HTMLStencilElement {
    }
    var HTMLFlowBusyOverlayElement: {
        prototype: HTMLFlowBusyOverlayElement;
        new (): HTMLFlowBusyOverlayElement;
    };
    interface HTMLFlowButtonElement extends Components.FlowButton, HTMLStencilElement {
    }
    var HTMLFlowButtonElement: {
        prototype: HTMLFlowButtonElement;
        new (): HTMLFlowButtonElement;
    };
    interface HTMLFlowChartElement extends Components.FlowChart, HTMLStencilElement {
    }
    var HTMLFlowChartElement: {
        prototype: HTMLFlowChartElement;
        new (): HTMLFlowChartElement;
    };
    interface HTMLFlowChartDataElement extends Components.FlowChartData, HTMLStencilElement {
    }
    var HTMLFlowChartDataElement: {
        prototype: HTMLFlowChartDataElement;
        new (): HTMLFlowChartDataElement;
    };
    interface HTMLFlowChartSignalElement extends Components.FlowChartSignal, HTMLStencilElement {
    }
    var HTMLFlowChartSignalElement: {
        prototype: HTMLFlowChartSignalElement;
        new (): HTMLFlowChartSignalElement;
    };
    interface HTMLFlowCheckboxElement extends Components.FlowCheckbox, HTMLStencilElement {
    }
    var HTMLFlowCheckboxElement: {
        prototype: HTMLFlowCheckboxElement;
        new (): HTMLFlowCheckboxElement;
    };
    interface HTMLFlowCheckboxGroupElement extends Components.FlowCheckboxGroup, HTMLStencilElement {
    }
    var HTMLFlowCheckboxGroupElement: {
        prototype: HTMLFlowCheckboxGroupElement;
        new (): HTMLFlowCheckboxGroupElement;
    };
    interface HTMLFlowChipElement extends Components.FlowChip, HTMLStencilElement {
    }
    var HTMLFlowChipElement: {
        prototype: HTMLFlowChipElement;
        new (): HTMLFlowChipElement;
    };
    interface HTMLFlowContextElement extends Components.FlowContext, HTMLStencilElement {
    }
    var HTMLFlowContextElement: {
        prototype: HTMLFlowContextElement;
        new (): HTMLFlowContextElement;
    };
    interface HTMLFlowDataColumnElement extends Components.FlowDataColumn, HTMLStencilElement {
    }
    var HTMLFlowDataColumnElement: {
        prototype: HTMLFlowDataColumnElement;
        new (): HTMLFlowDataColumnElement;
    };
    interface HTMLFlowDataTableElement extends Components.FlowDataTable, HTMLStencilElement {
    }
    var HTMLFlowDataTableElement: {
        prototype: HTMLFlowDataTableElement;
        new (): HTMLFlowDataTableElement;
    };
    interface HTMLFlowDateTimePickerElement extends Components.FlowDateTimePicker, HTMLStencilElement {
    }
    var HTMLFlowDateTimePickerElement: {
        prototype: HTMLFlowDateTimePickerElement;
        new (): HTMLFlowDateTimePickerElement;
    };
    interface HTMLFlowDialogElement extends Components.FlowDialog, HTMLStencilElement {
    }
    var HTMLFlowDialogElement: {
        prototype: HTMLFlowDialogElement;
        new (): HTMLFlowDialogElement;
    };
    interface HTMLFlowDrawerElement extends Components.FlowDrawer, HTMLStencilElement {
    }
    var HTMLFlowDrawerElement: {
        prototype: HTMLFlowDrawerElement;
        new (): HTMLFlowDrawerElement;
    };
    interface HTMLFlowDrawerContainerElement extends Components.FlowDrawerContainer, HTMLStencilElement {
    }
    var HTMLFlowDrawerContainerElement: {
        prototype: HTMLFlowDrawerContainerElement;
        new (): HTMLFlowDrawerContainerElement;
    };
    interface HTMLFlowFabElement extends Components.FlowFab, HTMLStencilElement {
    }
    var HTMLFlowFabElement: {
        prototype: HTMLFlowFabElement;
        new (): HTMLFlowFabElement;
    };
    interface HTMLFlowFabGroupElement extends Components.FlowFabGroup, HTMLStencilElement {
    }
    var HTMLFlowFabGroupElement: {
        prototype: HTMLFlowFabGroupElement;
        new (): HTMLFlowFabGroupElement;
    };
    interface HTMLFlowGaugeElement extends Components.FlowGauge, HTMLStencilElement {
    }
    var HTMLFlowGaugeElement: {
        prototype: HTMLFlowGaugeElement;
        new (): HTMLFlowGaugeElement;
    };
    interface HTMLFlowIconElement extends Components.FlowIcon, HTMLStencilElement {
    }
    var HTMLFlowIconElement: {
        prototype: HTMLFlowIconElement;
        new (): HTMLFlowIconElement;
    };
    interface HTMLFlowInputElement extends Components.FlowInput, HTMLStencilElement {
    }
    var HTMLFlowInputElement: {
        prototype: HTMLFlowInputElement;
        new (): HTMLFlowInputElement;
    };
    interface HTMLFlowListElement extends Components.FlowList, HTMLStencilElement {
    }
    var HTMLFlowListElement: {
        prototype: HTMLFlowListElement;
        new (): HTMLFlowListElement;
    };
    interface HTMLFlowListDividerElement extends Components.FlowListDivider, HTMLStencilElement {
    }
    var HTMLFlowListDividerElement: {
        prototype: HTMLFlowListDividerElement;
        new (): HTMLFlowListDividerElement;
    };
    interface HTMLFlowListGroupElement extends Components.FlowListGroup, HTMLStencilElement {
    }
    var HTMLFlowListGroupElement: {
        prototype: HTMLFlowListGroupElement;
        new (): HTMLFlowListGroupElement;
    };
    interface HTMLFlowListHeaderElement extends Components.FlowListHeader, HTMLStencilElement {
    }
    var HTMLFlowListHeaderElement: {
        prototype: HTMLFlowListHeaderElement;
        new (): HTMLFlowListHeaderElement;
    };
    interface HTMLFlowListItemElement extends Components.FlowListItem, HTMLStencilElement {
    }
    var HTMLFlowListItemElement: {
        prototype: HTMLFlowListItemElement;
        new (): HTMLFlowListItemElement;
    };
    interface HTMLFlowMapElement extends Components.FlowMap, HTMLStencilElement {
    }
    var HTMLFlowMapElement: {
        prototype: HTMLFlowMapElement;
        new (): HTMLFlowMapElement;
    };
    interface HTMLFlowMapDataJoinElement extends Components.FlowMapDataJoin, HTMLStencilElement {
    }
    var HTMLFlowMapDataJoinElement: {
        prototype: HTMLFlowMapDataJoinElement;
        new (): HTMLFlowMapDataJoinElement;
    };
    interface HTMLFlowMapDataSourceElement extends Components.FlowMapDataSource, HTMLStencilElement {
    }
    var HTMLFlowMapDataSourceElement: {
        prototype: HTMLFlowMapDataSourceElement;
        new (): HTMLFlowMapDataSourceElement;
    };
    interface HTMLFlowMapIconElement extends Components.FlowMapIcon, HTMLStencilElement {
    }
    var HTMLFlowMapIconElement: {
        prototype: HTMLFlowMapIconElement;
        new (): HTMLFlowMapIconElement;
    };
    interface HTMLFlowMapLayerElement extends Components.FlowMapLayer, HTMLStencilElement {
    }
    var HTMLFlowMapLayerElement: {
        prototype: HTMLFlowMapLayerElement;
        new (): HTMLFlowMapLayerElement;
    };
    interface HTMLFlowMapParameterElement extends Components.FlowMapParameter, HTMLStencilElement {
    }
    var HTMLFlowMapParameterElement: {
        prototype: HTMLFlowMapParameterElement;
        new (): HTMLFlowMapParameterElement;
    };
    interface HTMLFlowMapPopupElement extends Components.FlowMapPopup, HTMLStencilElement {
    }
    var HTMLFlowMapPopupElement: {
        prototype: HTMLFlowMapPopupElement;
        new (): HTMLFlowMapPopupElement;
    };
    interface HTMLFlowProgressBarElement extends Components.FlowProgressBar, HTMLStencilElement {
    }
    var HTMLFlowProgressBarElement: {
        prototype: HTMLFlowProgressBarElement;
        new (): HTMLFlowProgressBarElement;
    };
    interface HTMLFlowProgressRingElement extends Components.FlowProgressRing, HTMLStencilElement {
    }
    var HTMLFlowProgressRingElement: {
        prototype: HTMLFlowProgressRingElement;
        new (): HTMLFlowProgressRingElement;
    };
    interface HTMLFlowRadioElement extends Components.FlowRadio, HTMLStencilElement {
    }
    var HTMLFlowRadioElement: {
        prototype: HTMLFlowRadioElement;
        new (): HTMLFlowRadioElement;
    };
    interface HTMLFlowRadioGroupElement extends Components.FlowRadioGroup, HTMLStencilElement {
    }
    var HTMLFlowRadioGroupElement: {
        prototype: HTMLFlowRadioGroupElement;
        new (): HTMLFlowRadioGroupElement;
    };
    interface HTMLFlowTabElement extends Components.FlowTab, HTMLStencilElement {
    }
    var HTMLFlowTabElement: {
        prototype: HTMLFlowTabElement;
        new (): HTMLFlowTabElement;
    };
    interface HTMLFlowTabGroupElement extends Components.FlowTabGroup, HTMLStencilElement {
    }
    var HTMLFlowTabGroupElement: {
        prototype: HTMLFlowTabGroupElement;
        new (): HTMLFlowTabGroupElement;
    };
    interface HTMLFlowTabPanelElement extends Components.FlowTabPanel, HTMLStencilElement {
    }
    var HTMLFlowTabPanelElement: {
        prototype: HTMLFlowTabPanelElement;
        new (): HTMLFlowTabPanelElement;
    };
    interface HTMLFlowTimerElement extends Components.FlowTimer, HTMLStencilElement {
    }
    var HTMLFlowTimerElement: {
        prototype: HTMLFlowTimerElement;
        new (): HTMLFlowTimerElement;
    };
    interface HTMLFlowTooltipElement extends Components.FlowTooltip, HTMLStencilElement {
    }
    var HTMLFlowTooltipElement: {
        prototype: HTMLFlowTooltipElement;
        new (): HTMLFlowTooltipElement;
    };
    interface HTMLFlowValueElement extends Components.FlowValue, HTMLStencilElement {
    }
    var HTMLFlowValueElement: {
        prototype: HTMLFlowValueElement;
        new (): HTMLFlowValueElement;
    };
    interface HTMLElementTagNameMap {
        "flow-badge": HTMLFlowBadgeElement;
        "flow-busy-overlay": HTMLFlowBusyOverlayElement;
        "flow-button": HTMLFlowButtonElement;
        "flow-chart": HTMLFlowChartElement;
        "flow-chart-data": HTMLFlowChartDataElement;
        "flow-chart-signal": HTMLFlowChartSignalElement;
        "flow-checkbox": HTMLFlowCheckboxElement;
        "flow-checkbox-group": HTMLFlowCheckboxGroupElement;
        "flow-chip": HTMLFlowChipElement;
        "flow-context": HTMLFlowContextElement;
        "flow-data-column": HTMLFlowDataColumnElement;
        "flow-data-table": HTMLFlowDataTableElement;
        "flow-date-time-picker": HTMLFlowDateTimePickerElement;
        "flow-dialog": HTMLFlowDialogElement;
        "flow-drawer": HTMLFlowDrawerElement;
        "flow-drawer-container": HTMLFlowDrawerContainerElement;
        "flow-fab": HTMLFlowFabElement;
        "flow-fab-group": HTMLFlowFabGroupElement;
        "flow-gauge": HTMLFlowGaugeElement;
        "flow-icon": HTMLFlowIconElement;
        "flow-input": HTMLFlowInputElement;
        "flow-list": HTMLFlowListElement;
        "flow-list-divider": HTMLFlowListDividerElement;
        "flow-list-group": HTMLFlowListGroupElement;
        "flow-list-header": HTMLFlowListHeaderElement;
        "flow-list-item": HTMLFlowListItemElement;
        "flow-map": HTMLFlowMapElement;
        "flow-map-data-join": HTMLFlowMapDataJoinElement;
        "flow-map-data-source": HTMLFlowMapDataSourceElement;
        "flow-map-icon": HTMLFlowMapIconElement;
        "flow-map-layer": HTMLFlowMapLayerElement;
        "flow-map-parameter": HTMLFlowMapParameterElement;
        "flow-map-popup": HTMLFlowMapPopupElement;
        "flow-progress-bar": HTMLFlowProgressBarElement;
        "flow-progress-ring": HTMLFlowProgressRingElement;
        "flow-radio": HTMLFlowRadioElement;
        "flow-radio-group": HTMLFlowRadioGroupElement;
        "flow-tab": HTMLFlowTabElement;
        "flow-tab-group": HTMLFlowTabGroupElement;
        "flow-tab-panel": HTMLFlowTabPanelElement;
        "flow-timer": HTMLFlowTimerElement;
        "flow-tooltip": HTMLFlowTooltipElement;
        "flow-value": HTMLFlowValueElement;
    }
}
declare namespace LocalJSX {
    interface FlowBadge {
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to true to draw a pill-style badge with rounded corners.
         */
        "pill"?: boolean;
        /**
          * Set to true to make the badge pulse.
         */
        "pulse"?: boolean;
    }
    interface FlowBusyOverlay {
        /**
          * Set to `true` to display the busy overlay. Specify a Flo.w reactive expression or a boolean value.
          * @reactive
         */
        "busy"?: string;
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Set to `true` to overlay the component's parent element rather than its content.
         */
        "overlayParent"?: boolean;
        /**
          * The size of the progress ring.
         */
        "size"?: 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
    }
    interface FlowButton {
        /**
          * The color of the component. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to display a smaller-sized button with reduced margins.
         */
        "compact"?: boolean;
        /**
          * Set to `true` to disable interaction with the button.
         */
        "disabled"?: boolean;
        /**
          * Specify that the linked file should be downloaded using this filename. Only used when `href` is set.
         */
        "download"?: string;
        /**
          * When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`.
         */
        "href"?: string;
        /**
          * Set to display an icon on the button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Set to `true` to display an 'icon-only' button with no button body or label. Note that the default color of an 'icon-only' button is the current text color. Use the `color` property to select a different color from the application palette.
         */
        "iconButton"?: boolean;
        /**
          * If set, specifies the button label text. Otherwise, the text content of the element is used as the button label text.
         */
        "label"?: string;
        /**
          * Set to display an 'outlined' button.
         */
        "outlined"?: boolean;
        /**
          * Set to display a 'solid' button.
         */
        "solid"?: boolean;
        /**
          * Set to 'true' to indicate that activating the button should submit the form. Ignored when `href` is set.
         */
        "submit"?: boolean;
        /**
          * Specify a target for opening the link. Only used when `href` is set.
         */
        "target"?: '_blank' | '_parent' | '_self' | '_top';
        /**
          * Set to `true` to display the icon *after* the label (to the right in LTR mode).
         */
        "trailingIcon"?: boolean;
    }
    interface FlowChart {
        /**
          * The registered chart specification to display.
         */
        "chartSpec"?: string;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The height of the chart in pixels.
         */
        "height"?: number;
        /**
          * Emitted when a chart signal has changed.
         */
        "onFlowChartSignalChanged"?: (event: FlowChartCustomEvent<FlowChartSignalChangeDetails>) => void;
        /**
          * Set to enable the Vega Tooltip plugin.
         */
        "tooltip"?: boolean;
        /**
          * The width of the chart in pixels.
         */
        "width"?: number;
    }
    interface FlowChartData {
        /**
          * The data to bind to the chart.  A reactive expression or an array of data objects.
          * @reactive
         */
        "data"?: string | Array<Record<string, any>>;
        /**
          * The named chart data to bind.
         */
        "name"?: string;
        /**
          * The data 'x' property (optional).
         */
        "x"?: string;
        /**
          * The data 'y' property (optional).
         */
        "y"?: string;
    }
    interface FlowChartSignal {
        /**
          * The name of the Vega signal to bind.
         */
        "name"?: string;
        /**
          * The Flo.w reactive expression to bind to the signal.
          * @reactive
         */
        "value"?: string;
    }
    interface FlowCheckbox {
        /**
          * The checkbox position relative to its label.
         */
        "align"?: 'start' | 'end';
        /**
          * The checked state of the checkbox.
         */
        "checked"?: boolean;
        /**
          * The color of the checkbox. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable interaction with the checkbox.
         */
        "disabled"?: boolean;
        /**
          * Set to `true` to enable the indeterminate checkbox state.
         */
        "indeterminate"?: boolean;
        /**
          * If set, specifies the checkbox label text. Otherwise, the text content of the element is used as the label text.
         */
        "label"?: string;
        /**
          * The name attribute of the checkbox.
         */
        "name"?: string;
        /**
          * Emitted when the checkbox loses focus.
         */
        "onFlowBlur"?: (event: FlowCheckboxCustomEvent<any>) => void;
        /**
          * Emitted when the checked state changes.
         */
        "onFlowChange"?: (event: FlowCheckboxCustomEvent<any>) => void;
        /**
          * Emitted when the checkbox gains focus.
         */
        "onFlowFocus"?: (event: FlowCheckboxCustomEvent<any>) => void;
        /**
          * The value attribute of the checkbox.
         */
        "value"?: string;
    }
    interface FlowCheckboxGroup {
        /**
          * Set to `true` to disable interaction with the checkbox group.
         */
        "disabled"?: boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Emitted when the control's checked state changes.
         */
        "onFlowCheckboxGroupChange"?: (event: FlowCheckboxGroupCustomEvent<any>) => void;
        /**
          * Set to bind a Flo.w application state property to the group. The state property is an array of `value` attributes corresponding to checked checkboxes.
          * @reactive
         */
        "selectionState"?: string;
        /**
          * The value attribute of the checkbox group.
         */
        "value"?: string[];
    }
    interface FlowChip {
        /**
          * Set to `true` to make the tag clearable.
         */
        "clearable"?: boolean;
        /**
          * The color of the chip. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Emitted when the clear button is activated.
         */
        "onFlowClear"?: (event: FlowChipCustomEvent<any>) => void;
        /**
          * Set to `true` to draw a pill-style tag with rounded edges.
         */
        "pill"?: boolean;
        /**
          * The chip's size.
         */
        "size"?: 'small' | 'medium' | 'large';
    }
    interface FlowContext {
        /**
          * The Flo.w API key for accessing the Flo.w REST API.
         */
        "apiKey"?: string;
        /**
          * The Flo.w context ID. Specify to use multiple contexts.
         */
        "contextId"?: string;
        /**
          * The Flo.w host URL for accessing the Flo.w REST API.
         */
        "host"?: string;
        /**
          * Emitted when the context is initialized.
         */
        "onFlowContextInitialized"?: (event: FlowContextCustomEvent<FlowCoreContext>) => void;
    }
    interface FlowDataColumn {
        /**
          * The column alignment.
         */
        "align"?: 'left' | 'right' | 'center';
        /**
          * Set to `true` to allow HTML content in the column.
         */
        "allowHtml"?: boolean;
        /**
          * Specify a data formatting string or custom format function.
         */
        "format"?: string | FormatFunction;
        /**
          * The name of the table column.
         */
        "name"?: string;
        /**
          * Emitted when the column properties are changed.
         */
        "onFlowChange"?: (event: FlowDataColumnCustomEvent<any>) => void;
        /**
          * The data object property to display in this column.
         */
        "property"?: string;
        /**
          * Set to `true` to enable column sorting controls.
         */
        "sortable"?: boolean;
        /**
          * The column width (with CSS units).
         */
        "width"?: string;
    }
    interface FlowDataTable {
        /**
          * Set to `true` to display a compact table with reduced font size and padding.
         */
        "compact"?: boolean;
        /**
          * Set to bind data to the table. May be a Flo.w reactive expression, an array of data objects or a single data object.
          * @reactive
         */
        "data"?: string | object[] | object;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Set to `true` to enable full row selection (requires rowSelect).
         */
        "fullRowSelect"?: boolean;
        /**
          * Set to `true` to disable horizontal scrolling of table data.
         */
        "noScroll"?: boolean;
        /**
          * Emitted when all rows are selected using the row selection controls. Only applicable when `rowSelect` is enabled.
         */
        "onFlowRowSelectedAll"?: (event: FlowDataTableCustomEvent<any>) => void;
        /**
          * Emitted when all rows are deselected using the row selection controls. Only applicable when `rowSelect` is enabled.
         */
        "onFlowRowSelectedNone"?: (event: FlowDataTableCustomEvent<any>) => void;
        /**
          * Emitted when the row selection state changes. Only applicable when `rowSelect` is enabled.
         */
        "onFlowRowSelectionChanged"?: (event: FlowDataTableCustomEvent<RowSelectionChangedEventDetail>) => void;
        /**
          * Emitted when a column sort action is performed. Only applicable when sorting is enabled for a table column.
         */
        "onFlowSortAction"?: (event: FlowDataTableCustomEvent<SortActionEventDetail>) => void;
        /**
          * Specify a data object property to use as a row ID.
         */
        "rowId"?: string;
        /**
          * Set to `true` to enable row selection.
         */
        "rowSelect"?: boolean;
        /**
          * Specify a data object property to use as a row type. The row type can be used to style table rows based on row data.
         */
        "rowType"?: string;
        /**
          * Set to `false` to hide the header row.
         */
        "showHeader"?: boolean;
        /**
          * Set to `true` to keep the header row in place when scrolling the table data.
         */
        "stickyHeader"?: boolean;
        /**
          * Set to `true` to allow wrapping of table cell contents.
         */
        "wrap"?: boolean;
    }
    interface FlowDateTimePicker {
        /**
          * Set to `true` to display a border.
         */
        "border"?: boolean;
        /**
          * Specify 12 or 24 hour clock format.
         */
        "clockMode"?: '12' | '24';
        /**
          * The accent color of the popup date/time selector. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable the date/time picker.
         */
        "disabled"?: boolean;
        /**
          * Set to `true` to enable seconds in the display.
         */
        "enableSeconds"?: boolean;
        /**
          * Set to `true` to enable fixed positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "fixed"?: boolean;
        /**
          * The display format for the selected date/time.
         */
        "format"?: string;
        /**
          * The maximum date/time that can be selected (ISO8601 string or Date object).
         */
        "maxDate"?: string | Date;
        /**
          * The minimum date/time that can be selected (ISO8601 string or Date object).
         */
        "minDate"?: string | Date;
        /**
          * Adjusts the step for the minute input.
         */
        "minuteIncrement"?: number;
        /**
          * The date/time mode.
         */
        "mode"?: 'date' | 'time' | 'datetime';
        /**
          * Emitted when the selected date/time is changed by user interaction.
         */
        "onFlowChange"?: (event: FlowDateTimePickerCustomEvent<DateTimePickerChangeEventDetail>) => void;
        /**
          * Emitted when the popup date/time selector is opened.
         */
        "onFlowDateTimeOpened"?: (event: FlowDateTimePickerCustomEvent<void>) => void;
        /**
          * Set to `true` to open the date/time picker on mouse click.
         */
        "openOnClick"?: boolean;
        /**
          * The input placeholder.
         */
        "placeholder"?: string;
        /**
          * The position of the popup date/time selector.
         */
        "position"?: 'above' | 'below' | 'auto';
        /**
          * Set to `true` to enable static positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "static"?: boolean;
        /**
          * Set display timezone using TZ identifier (e.g. Europe/London, default is local time)
         */
        "timezone"?: string;
        /**
          * Set display mode to UTC (note that when set to `true` this overrides the `timezone` attribute)
         */
        "utc"?: boolean;
        /**
          * The value of the picker. ISO8601 string
         */
        "value"?: string | undefined | null;
    }
    interface FlowDialog {
        /**
          * Specifies the dialog action to emit when closing the dialog via the `escape` key. Set to the empty string to disable closing by this method.
         */
        "escapeKeyAction"?: string;
        /**
          * Emitted after the dialog has been closed. The dialog action is specified in the event detail.
         */
        "onFlowDialogClosed"?: (event: FlowDialogCustomEvent<any>) => void;
        /**
          * Emitted when the dialog has been closing. The dialog action is specified in the event detail.
         */
        "onFlowDialogClosing"?: (event: FlowDialogCustomEvent<any>) => void;
        /**
          * Emitted after the dialog has been opened and is visible.
         */
        "onFlowDialogOpened"?: (event: FlowDialogCustomEvent<any>) => void;
        /**
          * Emitted when the dialog is opening.
         */
        "onFlowDialogOpening"?: (event: FlowDialogCustomEvent<any>) => void;
        /**
          * Specifies the dialog action to emit when closing the dialog by clicking on the scrim. Set to the empty string to disable closing by this method.
         */
        "scrimClickAction"?: string;
    }
    interface FlowDrawer {
        /**
          * Emitted when the drawer has closed.
         */
        "onFlowDrawerClosed"?: (event: FlowDrawerCustomEvent<any>) => void;
        /**
          * Emitted when the drawer is closing.
         */
        "onFlowDrawerClosing"?: (event: FlowDrawerCustomEvent<any>) => void;
        /**
          * Emitted when the drawer has opened.
         */
        "onFlowDrawerOpened"?: (event: FlowDrawerCustomEvent<any>) => void;
        /**
          * Emitted when the drawer is opening.
         */
        "onFlowDrawerOpening"?: (event: FlowDrawerCustomEvent<any>) => void;
        /**
          * Set to `true` to open the drawer.
         */
        "open"?: boolean;
        /**
          * The side of the parent element to which the drawer is attached.
         */
        "position"?: 'start' | 'end';
        /**
          * Set to `true` to display a 'side tab', which can be used to toggle the open state of the drawer.
         */
        "sideTab"?: boolean;
    }
    interface FlowDrawerContainer {
        /**
          * Emitted when the container drawer state changes.
         */
        "onFlowDrawerChanged"?: (event: FlowDrawerContainerCustomEvent<FlowDrawChangedEvent>) => void;
    }
    interface FlowFab {
        /**
          * Set to `true` for the FAB to act like a checkbox.
         */
        "checkbox"?: boolean;
        /**
          * The checked state of the FAB. Only applicable if `checkbox` is set to `true`.
         */
        "checked"?: boolean;
        /**
          * The color of the FAB. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to display a smaller FAB.
         */
        "compact"?: boolean;
        /**
          * Set to display an icon on the button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Set to add an optional label to the FAB.
         */
        "label"?: string;
        /**
          * Set to `true` to display the FAB using the 'square' style. By default, FABs are round.
         */
        "square"?: boolean;
        /**
          * The value attribute of the FAB. Only applicable if `checkbox` is set to `true`.
         */
        "value"?: string;
    }
    interface FlowFabGroup {
        /**
          * Specify the direction in which to expand buttons when the FAB group is opened.
         */
        "direction"?: 'up' | 'down' | 'left' | 'right';
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The icon of the main FAB group button. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Set this attribute to `true` to force the FAB group to open. The open state will be toggled automatically when the main FAB is clicked.
         */
        "open"?: boolean;
        /**
          * Set to bind a Flo.w application state property to the group. The state property is an array of `value` attributes corresponding to checked FABs.
          * @reactive
         */
        "selectionState"?: string;
    }
    interface FlowGauge {
        /**
          * The color of the gauge value. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * The transition duration in milliseconds for the animation between numeric values. Set to zero to disable animation.
         */
        "duration"?: number;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The display format of the gauge value. Use a D3 format string for numeric values. Use `"icon"` to treat `value` as an icon name.
         */
        "format"?: string;
        /**
          * The gauge heading text.
         */
        "heading"?: string;
        /**
          * Set to display an icon in the gauge heading. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * The units text to display under the gauge value.
         */
        "units"?: string;
        /**
          * The gauge value specified as a Flo.w reactive expression.
          * @reactive
         */
        "value"?: string;
    }
    interface FlowIcon {
        /**
          * Specifies the label to use for accessibility. Defaults to the icon name.
         */
        "ariaLabel"?: string | null;
        /**
          * The color of the gauge value. Colors are taken from the application palette. If unset, the current color will be used.
         */
        "color"?: PredefinedColor;
        /**
          * The name of a built-in icon or URL to an SVG file.
         */
        "icon"?: any;
        /**
          * If enabled, the icon will be loaded lazily when it is visible in the viewport.
         */
        "lazy"?: boolean;
        /**
          * The size of the icon. If not specified, the current font-size will be used.
         */
        "size"?: 'x-small' | 'small' | 'regular' | 'large' | 'x-large';
    }
    interface FlowInput {
        /**
          * The color of the control. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable interaction with the input control.
         */
        "disabled"?: boolean;
        /**
          * An icon to place before the input. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * The label text.
         */
        "label"?: string;
        /**
          * The name attribute of the native input control
         */
        "name"?: string;
        /**
          * Emitted when the control's value changes.
         */
        "onFlowChange"?: (event: FlowInputCustomEvent<any>) => void;
        /**
          * Emitted when the control receives input.
         */
        "onFlowInput"?: (event: FlowInputCustomEvent<any>) => void;
        /**
          * Emitted when trailing action icon is clicked.
         */
        "onFlowInputAction"?: (event: FlowInputCustomEvent<any>) => void;
        /**
          * Prefix text to place before the input.
         */
        "prefixText"?: string;
        /**
          * Suffix text to place after the input.
         */
        "suffixText"?: string;
        /**
          * An icon action button to place after the input. The property can be the name of a built-in icon, a URL of an SVG file, or an SVG data URI.
         */
        "trailingIcon"?: string;
        /**
          * The style of the input control.
         */
        "type"?: 'filled' | 'outlined' | 'plain';
        /**
          * The value of the input control.
         */
        "value"?: string;
    }
    interface FlowList {
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Emitted when a list action occurs.
         */
        "onFlowListAction"?: (event: FlowListCustomEvent<FlowListActionEventDetail>) => void;
        /**
          * Set to bind a Flo.w application state property to this list. Radio or check-box list changes will be reflected in state property changes and vice versa.
          * @reactive
         */
        "selectionState"?: string;
        /**
          * Set to `true` to enable 'single selection' mode. The list will have a single selected item displayed in a distinct style.
         */
        "singleSelection"?: boolean;
        /**
          * Set to `true` to support two-line list items.
         */
        "twoLine"?: boolean;
    }
    interface FlowListDivider {
        /**
          * Set to `true` to inset the divider past the list text.
         */
        "inset"?: boolean;
        /**
          * Set to `true` to pad the divider to align with the list text.
         */
        "padded"?: boolean;
        /**
          * Set to display text above the divider line.
         */
        "text"?: string;
    }
    interface FlowListGroup {
    }
    interface FlowListHeader {
        /**
          * Set to `true` to display an expand/collapse button and make the following `flow-list` collapsible.
         */
        "collapsible"?: boolean;
        /**
          * The color of list header text and optional icon. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to display an icon before the title of the header. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Set to open or close the following `flow-list`. Only applicable if `collapsible` is `true`.
         */
        "open"?: boolean;
    }
    interface FlowListItem {
        /**
          * Set to `true` to indicate that this item is 'activated', that is, represents a highlighted destination.
         */
        "activated"?: boolean;
        /**
          * Indicate the checked state of a checkbox list item.
         */
        "checked"?: boolean;
        /**
          * The color of the list item. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable user interaction with the list item.
         */
        "disabled"?: boolean;
        /**
          * Set to display a leading icon before the item text. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "icon"?: string;
        /**
          * Specifies the first line a two-line list item.
         */
        "lineOne"?: string;
        /**
          * Specifies the second line a two-line list item.
         */
        "lineTwo"?: string;
        /**
          * Set to `true` to indicate that this item is 'selected', that is, represents a user selection of options.
         */
        "selected"?: boolean;
        /**
          * Set to display a trailing icon after the item text. The property can be the name of a built-in icon, a URL to an SVG file, or an SVG data URI.
         */
        "trailingIcon"?: string;
        /**
          * Specifies the type of the list item. The default type is `"list"`, which displays option icons and item text but no controls.
         */
        "type"?: 'list' | 'radio' | 'checkbox';
        /**
          * Specifies the value of the list item. The value is used to identify the list item in list events, to programmatically select a list item, and to set state properties when using application state binding.
         */
        "value"?: any;
    }
    interface FlowMap {
        /**
          * Set to `true` to activate the map busy indicator.
         */
        "busyIndicator"?: boolean;
        /**
          * The initial position and zoom for the map (format: `"lng,lat,zoom"`). If unset the default position and zoom from the map style will be used.
         */
        "center"?: string;
        /**
          * Specify radius in pixels of area around clicked point to search for map features.
         */
        "featureClickTolerance"?: number;
        /**
          * Position the map canvas using fixed positioning to take up the entire window. UI elements that should appear on top of the map (sidebars, drawers, etc.) must have z-index set to 1 or higher to appear above the rendered map.
         */
        "fixedPosition"?: boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The base map style ID.
         */
        "mapStyle"?: string;
        /**
          * Emitted when the user clicks on the map.
         */
        "onFlowMapClick"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the user double-clicks on the map.
         */
        "onFlowMapDblClick"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the initial map style has loaded.
         */
        "onFlowMapLoad"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the map has finished zooming or panning.
         */
        "onFlowMapMoveEnd"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the selection feature state of a data source changes.
         */
        "onFlowMapSelectionFeatureStateChanged"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the selection state of a data source changes.
         */
        "onFlowMapSelectionStateChanged"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the user clicks on the map.
          * @deprecated Use flowMapClick.
         */
        "onMapClick"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the user double-clicks on the map.
          * @deprecated Use flowMapDblClick.
         */
        "onMapDblClick"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the initial map style has loaded.
          * @deprecated Use flowMapLoad.
         */
        "onMapLoad"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Emitted when the map has finished zooming or panning.
          * @deprecated Use flowMapMoveEnd.
         */
        "onMapMoveEnd"?: (event: FlowMapCustomEvent<any>) => void;
        /**
          * Set to true to sync the map position, zoom, bearing and pitch with the browser URL.
         */
        "sync"?: boolean;
        /**
          * Set to true to automatically resize the map when its container is resized.
         */
        "trackResize"?: boolean;
    }
    interface FlowMapDataJoin {
        /**
          * Set to `true` to clear all current feature state before applying the data join.
         */
        "clear"?: boolean;
        /**
          * The foreign key property of the joined data. Data will be joined to features where the foreign key equals the feature ID.
         */
        "foreignKey"?: string;
        /**
          * The name of the data join.
          * @deprecated Use `id` attribute instead.
         */
        "name"?: string;
        /**
          * Specify the source layer in the target data source to join. Applicable only for vector data sources. Defaults to 'geometry'.
         */
        "sourceLayer"?: string;
        /**
          * The data to join. Specify a reactive expression or an array of data objects.
          * @reactive
         */
        "src"?: string | any[];
    }
    interface FlowMapDataSource {
        /**
          * Specify to override application-wide API key for this data source.
         */
        "apiKey"?: string;
        /**
          * Set to `true` to enable clustering of data points. (For GeoJSON point data sources only)
         */
        "cluster"?: boolean;
        /**
          * The maximum zoom level at which clustering of data points will occur. Above this zoom level data points will not be clustered. (For GeoJSON point data sources only)
         */
        "clusterMaxZoom"?: number;
        /**
          * The cluster radius for clustering of data points. (For GeoJSON point data sources only)
         */
        "clusterRadius"?: number;
        /**
          * The feature property that uniquely identifies feature. Required for data joins.
         */
        "featureId"?: string;
        /**
          * An optional limit applied when querying data
         */
        "limit"?: number;
        /**
          * The unique name of the data source.
          * @deprecated Use `id` attribute instead.
         */
        "name"?: string;
        /**
          * Set to `true` to clear the selection whenever the map is clicked (empty area or a feature from another data source).
         */
        "selectionClear"?: boolean | 'group';
        /**
          * Set to bind selected feature properties to a Flo.w application state property. Binding is one-way. The application state property is updated automatically when map feature selection changes. Setting the application state property programmatically has no effect.
          * @reactive
         */
        "selectionFeatureState"?: string;
        /**
          * Set specify the selection group for this data source. If `selectionClear` is set to `group` then this datasource's selection will be cleared when a feature from another data source in the same selection group is clicked.
         */
        "selectionGroup"?: any;
        /**
          * Enable automatic feature selection support for single or multiple features.
         */
        "selectionMode"?: 'none' | 'single' | 'multi';
        /**
          * Set to automatically open a popup when a map feature from this data source is clicked. The popup can be configured by specifying the ID of a registered `<flow-map-popup>` or programmatically by specifying a function that returns a `FlowCoreMapPopupOptions` object.
         */
        "selectionPopup"?: string | SelectionPopupFn;
        /**
          * Set to bind selected feature IDs to a Flo.w application state property. Binding is two-way. Set the associated application state property to programmatically modify feature selection for this data source.
          * @reactive
         */
        "selectionState"?: string;
        /**
          * The vector source layer to display. Defaults to 'geometry' for vector-type data sources. Omit for GeoJSON-type data sources.
         */
        "sourceLayer"?: string;
        /**
          * The source of the data. For vector data, specify a Flo.w tile source ID or a TileJSON URL. For GeoJSON data, specify a GeoJSON URL or a reactive expression returning GeoJSON data.
          * @reactive
         */
        "src"?: string | GeoJSON.FeatureCollection;
        /**
          * The type of the data source.
         */
        "type"?: 'vector' | 'geojson' | 'raster';
    }
    interface FlowMapIcon {
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The display height in pixels of the icon.
         */
        "height"?: number;
        /**
          * The unique ID of the icon.
          * @deprecated Use ID attribute instead.
         */
        "name"?: string;
        /**
          * The pixel density of the icon. To improve display quality on high resolution screens, map icons should be provided at 2x resolution and the default pixelDensity of 2 should be used.
         */
        "pixelDensity"?: number;
        /**
          * Set to `true` to allow recoloring of icon using map layer style properties.
         */
        "recolor"?: boolean;
        /**
          * The URL of a png or svg icon file.
         */
        "src"?: string;
        /**
          * The display width in pixels of the icon.
         */
        "width"?: number;
    }
    interface FlowMapLayer {
        /**
          * Specify to override the default layer ordering and place this layer above the named layer.
         */
        "above"?: string;
        /**
          * Specify to override the default layer ordering and place this layer below the named layer.
         */
        "below"?: string;
        /**
          * An optional layer filter. Specified as a Flo.w reactive expression.
          * @reactive
         */
        "filter"?: string;
        /**
          * Set to `true` to enable hover and click actions on the map layer.
         */
        "interactive"?: boolean;
        /**
          * @deprecated Do not use.
         */
        "layerStyle"?: string;
        /**
          * The maximum zoom level for the layer. Above this level, the layer will be hidden.
         */
        "maxZoom"?: number;
        "metadata"?: any;
        /**
          * The minimum zoom level for the layer. Below this level, the layer will be hidden.
         */
        "minZoom"?: number;
        /**
          * The name of the layer. Layer names should be unique for a particular map.
          * @deprecated Use `id` attribute instead.
         */
        "name"?: string;
        /**
          * The name of the map data source to display.
         */
        "source"?: string;
        /**
          * The vector source layer to display. Defaults to 'geometry' for vector-type data sources. Omit for GeoJSON-type data sources.
         */
        "sourceLayer"?: string;
        /**
          * The layer type.
         */
        "type"?: string;
    }
    interface FlowMapParameter {
        /**
          * The parameter name.
         */
        "name"?: string;
        /**
          * Set to `true` to disable data joining if this parameter is `null`.
         */
        "required"?: boolean;
        /**
          * The parameter value. A Flo.w reactive expression.
          * @reactive
         */
        "value"?: string;
    }
    interface FlowMapPopup {
        /**
          * Set to `true` to enable 'close' button.
         */
        "closeButton"?: boolean;
        /**
          * Set to `true` to close popup when map is clicked.
         */
        "closeOnClick"?: boolean;
        /**
          * Set to `true` to close popup when map is moved.
         */
        "closeOnMove"?: boolean;
        /**
          * Move popup to `trackLocation` immediately.
         */
        "fireTrackImmediately"?: boolean;
        /**
          * Maximum width of popup in CSS units.
         */
        "maxWidth"?: string;
        /**
          * The unique popup ID.
          * @deprecated Use `id` attribute instead.
         */
        "name"?: string;
        /**
          * Specify a CSS class to add to the popup.
         */
        "popupClass"?: string;
        /**
          * Move popup when feature location changes. Specify `true` to enable automatic location tracking as map feature moves or specify a reactive expression returning lng/lat as a 2-element array.
          * @reactive
         */
        "trackLocation"?: string | boolean;
    }
    interface FlowProgressBar {
        /**
          * The color of the progress indicator. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to show an indeterminate progress bar.
         */
        "indeterminate"?: boolean;
        /**
          * Set to a value between 0 and 1 to indicate current progress.
         */
        "value"?: number;
    }
    interface FlowProgressRing {
        /**
          * Set to `true` to automatically show the progress indicator when progress is between 0 and 1.
         */
        "autoShow"?: boolean;
        /**
          * The color of the progress indicator. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to show an indeterminate circular progress indicator.
         */
        "indeterminate"?: boolean;
        /**
          * Specify the size of the circular progress indicator.
         */
        "size"?: 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
        /**
          * Set to a value between 0 and 1 to indicate current progress.
         */
        "value"?: number;
    }
    interface FlowRadio {
        /**
          * The radio button position relative to its label.
         */
        "align"?: 'start' | 'end';
        /**
          * The checked state of the radio button
         */
        "checked"?: boolean;
        /**
          * The color of the radio button. Colors are taken from the application palette.
         */
        "color"?: PredefinedColor;
        /**
          * Set to `true` to disable interaction with the checkbox.
         */
        "disabled"?: boolean;
        /**
          * If set, specifies the radio button label text. Otherwise, the text content of the element is used as the label text.
         */
        "label"?: string;
        /**
          * The name attribute of the radio button.
         */
        "name"?: string;
        /**
          * Emitted when the control loses focus.
         */
        "onFlowBlur"?: (event: FlowRadioCustomEvent<any>) => void;
        /**
          * Emitted when the control's checked state changes.
         */
        "onFlowChange"?: (event: FlowRadioCustomEvent<any>) => void;
        /**
          * Emitted when the control gains focus.
         */
        "onFlowFocus"?: (event: FlowRadioCustomEvent<any>) => void;
        /**
          * The value attribute of the radio button.
         */
        "value"?: string;
    }
    interface FlowRadioGroup {
        /**
          * Set to `true` to disable interaction with the radio button group.
         */
        "disabled"?: boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Emitted when the control's checked state changes.
         */
        "onFlowRadioGroupChange"?: (event: FlowRadioGroupCustomEvent<any>) => void;
        /**
          * Set to bind a Flo.w application state property to this list. The state property value reflects the value of the selected radio button.
          * @reactive
         */
        "selectionState"?: string;
        /**
          * The value attribute of the radio button group.
         */
        "value"?: string;
    }
    interface FlowTab {
        /**
          * Set to true to draw the tab in an active state.
         */
        "active"?: boolean;
        /**
          * Set to true to draw the tab in a disabled state.
         */
        "disabled"?: boolean;
        /**
          * The name of the tab panel the tab will control. The panel must be located in the same tab group.
         */
        "panel"?: string;
    }
    interface FlowTabGroup {
        /**
          * Emitted when a tab is hidden.
         */
        "onFlowTabHide"?: (event: FlowTabGroupCustomEvent<any>) => void;
        /**
          * Emitted when a tab is shown.
         */
        "onFlowTabShow"?: (event: FlowTabGroupCustomEvent<any>) => void;
        /**
          * The placement of the tab navigation buttons.
         */
        "placement"?: 'top' | 'bottom' | 'left' | 'right';
    }
    interface FlowTabPanel {
        /**
          * Set to `true` to show the tab panel.
         */
        "active"?: boolean;
        /**
          * The tab panel's name.
         */
        "name"?: string;
    }
    interface FlowTimer {
        /**
          * Set to `true` to disable interaction with the timer.
         */
        "disabled"?: boolean;
        /**
          * Set to enable/disable the play button.
         */
        "enablePlay"?: boolean;
        /**
          * Set to `true` to enable fixed positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "fixed"?: boolean;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * The time interval for the major step buttons.
         */
        "majorStep"?: string;
        /**
          * The time interval for the minor step buttons.
         */
        "minorStep"?: string;
        /**
          * Emitted when the timer value has changed.
         */
        "onFlowChange"?: (event: FlowTimerCustomEvent<TimerChangeEventDetail>) => void;
        /**
          * The position of the popup date/time selectors relative to the timer control.
         */
        "position"?: 'above' | 'below' | 'auto';
        /**
          * Set to start/stop the timer. Read to retrieve the current running state.
         */
        "running"?: boolean;
        /**
          * Set to `true` to enable static positioning of popup calendars. By default calendars are positioned absolutely using body coordinates.
         */
        "static"?: boolean;
        /**
          * The Flo.w state property to bind to the timer. The state property will be synchronized with the value of the timer.
          * @reactive
         */
        "timerState"?: string;
        /**
          * Specifies the format of the Flo.w state property bound to the timer.
         */
        "timerStateFormat"?: 'iso' | 'millis';
        /**
          * Set display timezone using TZ identifier (e.g. Europe/London, default is local time)
         */
        "timezone"?: string;
        /**
          * Set to delay scheduled updates when the timer is running. This can be used to allow time for data to arrive in real-time use cases.
         */
        "updateDelay"?: string;
        /**
          * Specifies the frequency at which the timer emits updates when running. All emitted values are also rounded down using this interval. This guarantees that emitted values are always aligned to the interval specified.
         */
        "updateInterval"?: string;
        /**
          * Set display mode to UTC (note that setting this to `true` overrides the `timezone` attribute)
         */
        "utc"?: boolean;
        /**
          * Set to update the current date/time. Read to retrieve the current date/time.
         */
        "value"?: string;
    }
    interface FlowTooltip {
        /**
          * Set to `true` to disable triggering of the tooltip.
         */
        "disabled"?: boolean;
        /**
          * Specify the target element ID of the tooltip. This is an alternative to wrapping the target element with the tooltip.
         */
        "for"?: string;
        /**
          * The distance in pixels from which to offset the tooltip away from its target.
         */
        "offset"?: number;
        /**
          * Set to `true` to force the tooltip to display.
         */
        "open"?: boolean;
        /**
          * The preferred placement of the tooltip. Note that the actual placement may vary as needed to keep the tooltip inside of the viewport.
         */
        "position"?: | 'top'
    | 'top-start'
    | 'top-end'
    | 'right'
    | 'right-start'
    | 'right-end'
    | 'bottom'
    | 'bottom-start'
    | 'bottom-end'
    | 'left'
    | 'left-start'
    | 'left-end';
        /**
          * The tooltip text.
         */
        "tipText"?: string;
        /**
          * Controls how the tooltip is activated. Possible options include `click`, `hover`, `focus`, and `manual`. Multiple options can be passed by separating them with a space. When manual is used, the tooltip must be activated programmatically.
         */
        "trigger"?: string;
    }
    interface FlowValue {
        /**
          * Specifies the transition duration in milliseconds for the animation between numeric values. Set to zero to disable animation.
         */
        "duration"?: number;
        /**
          * The Flo.w context ID to use for application state.
         */
        "flowContext"?: string;
        /**
          * Specifies the display format. Use a D3 format string for numeric values. Use `"icon"` to treat `value` as an icon name.
         */
        "format"?: string;
        /**
          * Emitted when the value changes.
         */
        "onFlowDataValueChanged"?: (event: FlowValueCustomEvent<number | string>) => void;
        /**
          * Specifies the value to display as a Flo.w reactive expression.
          * @reactive
         */
        "value"?: string;
    }
    interface IntrinsicElements {
        "flow-badge": FlowBadge;
        "flow-busy-overlay": FlowBusyOverlay;
        "flow-button": FlowButton;
        "flow-chart": FlowChart;
        "flow-chart-data": FlowChartData;
        "flow-chart-signal": FlowChartSignal;
        "flow-checkbox": FlowCheckbox;
        "flow-checkbox-group": FlowCheckboxGroup;
        "flow-chip": FlowChip;
        "flow-context": FlowContext;
        "flow-data-column": FlowDataColumn;
        "flow-data-table": FlowDataTable;
        "flow-date-time-picker": FlowDateTimePicker;
        "flow-dialog": FlowDialog;
        "flow-drawer": FlowDrawer;
        "flow-drawer-container": FlowDrawerContainer;
        "flow-fab": FlowFab;
        "flow-fab-group": FlowFabGroup;
        "flow-gauge": FlowGauge;
        "flow-icon": FlowIcon;
        "flow-input": FlowInput;
        "flow-list": FlowList;
        "flow-list-divider": FlowListDivider;
        "flow-list-group": FlowListGroup;
        "flow-list-header": FlowListHeader;
        "flow-list-item": FlowListItem;
        "flow-map": FlowMap;
        "flow-map-data-join": FlowMapDataJoin;
        "flow-map-data-source": FlowMapDataSource;
        "flow-map-icon": FlowMapIcon;
        "flow-map-layer": FlowMapLayer;
        "flow-map-parameter": FlowMapParameter;
        "flow-map-popup": FlowMapPopup;
        "flow-progress-bar": FlowProgressBar;
        "flow-progress-ring": FlowProgressRing;
        "flow-radio": FlowRadio;
        "flow-radio-group": FlowRadioGroup;
        "flow-tab": FlowTab;
        "flow-tab-group": FlowTabGroup;
        "flow-tab-panel": FlowTabPanel;
        "flow-timer": FlowTimer;
        "flow-tooltip": FlowTooltip;
        "flow-value": FlowValue;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            "flow-badge": LocalJSX.FlowBadge & JSXBase.HTMLAttributes<HTMLFlowBadgeElement>;
            "flow-busy-overlay": LocalJSX.FlowBusyOverlay & JSXBase.HTMLAttributes<HTMLFlowBusyOverlayElement>;
            "flow-button": LocalJSX.FlowButton & JSXBase.HTMLAttributes<HTMLFlowButtonElement>;
            "flow-chart": LocalJSX.FlowChart & JSXBase.HTMLAttributes<HTMLFlowChartElement>;
            "flow-chart-data": LocalJSX.FlowChartData & JSXBase.HTMLAttributes<HTMLFlowChartDataElement>;
            "flow-chart-signal": LocalJSX.FlowChartSignal & JSXBase.HTMLAttributes<HTMLFlowChartSignalElement>;
            "flow-checkbox": LocalJSX.FlowCheckbox & JSXBase.HTMLAttributes<HTMLFlowCheckboxElement>;
            "flow-checkbox-group": LocalJSX.FlowCheckboxGroup & JSXBase.HTMLAttributes<HTMLFlowCheckboxGroupElement>;
            "flow-chip": LocalJSX.FlowChip & JSXBase.HTMLAttributes<HTMLFlowChipElement>;
            "flow-context": LocalJSX.FlowContext & JSXBase.HTMLAttributes<HTMLFlowContextElement>;
            "flow-data-column": LocalJSX.FlowDataColumn & JSXBase.HTMLAttributes<HTMLFlowDataColumnElement>;
            "flow-data-table": LocalJSX.FlowDataTable & JSXBase.HTMLAttributes<HTMLFlowDataTableElement>;
            "flow-date-time-picker": LocalJSX.FlowDateTimePicker & JSXBase.HTMLAttributes<HTMLFlowDateTimePickerElement>;
            "flow-dialog": LocalJSX.FlowDialog & JSXBase.HTMLAttributes<HTMLFlowDialogElement>;
            "flow-drawer": LocalJSX.FlowDrawer & JSXBase.HTMLAttributes<HTMLFlowDrawerElement>;
            "flow-drawer-container": LocalJSX.FlowDrawerContainer & JSXBase.HTMLAttributes<HTMLFlowDrawerContainerElement>;
            "flow-fab": LocalJSX.FlowFab & JSXBase.HTMLAttributes<HTMLFlowFabElement>;
            "flow-fab-group": LocalJSX.FlowFabGroup & JSXBase.HTMLAttributes<HTMLFlowFabGroupElement>;
            "flow-gauge": LocalJSX.FlowGauge & JSXBase.HTMLAttributes<HTMLFlowGaugeElement>;
            "flow-icon": LocalJSX.FlowIcon & JSXBase.HTMLAttributes<HTMLFlowIconElement>;
            "flow-input": LocalJSX.FlowInput & JSXBase.HTMLAttributes<HTMLFlowInputElement>;
            "flow-list": LocalJSX.FlowList & JSXBase.HTMLAttributes<HTMLFlowListElement>;
            "flow-list-divider": LocalJSX.FlowListDivider & JSXBase.HTMLAttributes<HTMLFlowListDividerElement>;
            "flow-list-group": LocalJSX.FlowListGroup & JSXBase.HTMLAttributes<HTMLFlowListGroupElement>;
            "flow-list-header": LocalJSX.FlowListHeader & JSXBase.HTMLAttributes<HTMLFlowListHeaderElement>;
            "flow-list-item": LocalJSX.FlowListItem & JSXBase.HTMLAttributes<HTMLFlowListItemElement>;
            "flow-map": LocalJSX.FlowMap & JSXBase.HTMLAttributes<HTMLFlowMapElement>;
            "flow-map-data-join": LocalJSX.FlowMapDataJoin & JSXBase.HTMLAttributes<HTMLFlowMapDataJoinElement>;
            "flow-map-data-source": LocalJSX.FlowMapDataSource & JSXBase.HTMLAttributes<HTMLFlowMapDataSourceElement>;
            "flow-map-icon": LocalJSX.FlowMapIcon & JSXBase.HTMLAttributes<HTMLFlowMapIconElement>;
            "flow-map-layer": LocalJSX.FlowMapLayer & JSXBase.HTMLAttributes<HTMLFlowMapLayerElement>;
            "flow-map-parameter": LocalJSX.FlowMapParameter & JSXBase.HTMLAttributes<HTMLFlowMapParameterElement>;
            "flow-map-popup": LocalJSX.FlowMapPopup & JSXBase.HTMLAttributes<HTMLFlowMapPopupElement>;
            "flow-progress-bar": LocalJSX.FlowProgressBar & JSXBase.HTMLAttributes<HTMLFlowProgressBarElement>;
            "flow-progress-ring": LocalJSX.FlowProgressRing & JSXBase.HTMLAttributes<HTMLFlowProgressRingElement>;
            "flow-radio": LocalJSX.FlowRadio & JSXBase.HTMLAttributes<HTMLFlowRadioElement>;
            "flow-radio-group": LocalJSX.FlowRadioGroup & JSXBase.HTMLAttributes<HTMLFlowRadioGroupElement>;
            "flow-tab": LocalJSX.FlowTab & JSXBase.HTMLAttributes<HTMLFlowTabElement>;
            "flow-tab-group": LocalJSX.FlowTabGroup & JSXBase.HTMLAttributes<HTMLFlowTabGroupElement>;
            "flow-tab-panel": LocalJSX.FlowTabPanel & JSXBase.HTMLAttributes<HTMLFlowTabPanelElement>;
            "flow-timer": LocalJSX.FlowTimer & JSXBase.HTMLAttributes<HTMLFlowTimerElement>;
            "flow-tooltip": LocalJSX.FlowTooltip & JSXBase.HTMLAttributes<HTMLFlowTooltipElement>;
            "flow-value": LocalJSX.FlowValue & JSXBase.HTMLAttributes<HTMLFlowValueElement>;
        }
    }
}
