import { PredefinedColor } from '../../utils/theme';
/**
 * @since 1.1
 * @status stable
 * @reactive
 *
 * @slot - The content to overlay
 */
export declare class BusyOverlay {
  private autorunDisposer;
  _busy: boolean;
  showProgress: boolean;
  /**
   * The color of the component. Colors are taken from the application palette.
   */
  color?: PredefinedColor;
  /**
   * The size of the progress ring.
   */
  size: 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
  /**
   * Set to `true` to display the busy overlay. Specify a Flo.w reactive expression or a boolean value.
   *
   * @reactive
   */
  busy: string;
  /**
   * Set to `true` to overlay the component's parent element rather than its content.
   */
  overlayParent: boolean;
  /**
   * The Flo.w context ID to use for application state.
   */
  flowContext: string;
  constructor();
  connectedCallback(): void;
  disconnectedCallback(): void;
  private subscribe;
  private unsubscribe;
  private handleTransitionEnd;
  render(): any;
}
