import { EventEmitter } from '../../../stencil-public-runtime';
import { HTMLStencilElement } from '../../../stencil-public-runtime';
import { FlowCoreChart } from '../../../core/charts/flow-core-chart';
export interface FlowChartSignalChangeDetails {
  name: string;
  value: any;
}
/**
 * @status stable
 */
export declare class FlowChart {
  private chartContainerEl;
  el: HTMLStencilElement;
  /** @internal */
  _chart: FlowCoreChart;
  /**
   * The registered chart specification to display.
   */
  chartSpec: string;
  /**
   * The Flo.w context ID to use for application state.
   */
  flowContext: string;
  /** The height of the chart in pixels. */
  height: number;
  /** The width of the chart in pixels. */
  width: number;
  /** Set to enable the Vega Tooltip plugin. */
  tooltip: boolean;
  /** Emitted when a chart signal has changed. */
  flowChartSignalChanged: EventEmitter<FlowChartSignalChangeDetails>;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): void;
  updateSize(): Promise<void>;
  private initializeChart;
  render(): any;
}
