import { EventEmitter, ComponentDidLoad } from '../../stencil-public-runtime';
/**
 * @since 2.0
 * @status stable
 * @reactive
 *
 * @slot - Child checkboxes to place in the checkbox group.
 *
 */
export declare class CheckboxGroup implements ComponentDidLoad {
  private initialized;
  private subscription;
  host: HTMLFlowCheckboxElement;
  /** The value attribute of the checkbox group. */
  value: string[];
  protected updateValue(value: string[], oldValue: string[]): Promise<void>;
  /**
   * Set to `true` to disable interaction with the checkbox group.
   */
  disabled: boolean;
  protected updateDisabled(disabled: boolean): void;
  /**
   * Set to bind a Flo.w application state property to the group. The state property
   * is an array of `value` attributes corresponding to checked checkboxes.
   *
   * @reactive
   */
  selectionState: string;
  /**
   * The Flo.w context ID to use for application state.
   */
  flowContext: string;
  /** Emitted when the control's checked state changes. */
  flowCheckboxGroupChange: EventEmitter;
  connectedCallback(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  connect(): void;
  disconnect(): void;
  /**
   * Update group value when radio is clicked
   */
  private onFlowChange;
  private subscribe;
  private unsubscribe;
  /**
   * Return all child radio elements
   */
  private getAllCheckboxes;
  private valuesEqual;
  render(): any;
}
