import { EventEmitter } from '../../stencil-public-runtime';
import { PredefinedColor } from '../../utils/theme';
/**
 * @since 1.0
 * @status stable
 *
 * @slot - The chip's content.
 *
 * @part label - The chip's label.
 * @part clear-button - The clear button.
 */
export declare class Chip {
  /**
   * The color of the chip. Colors are taken from the application palette.
   */
  color: PredefinedColor;
  /** The chip's size. */
  size: 'small' | 'medium' | 'large';
  /** Set to `true` to draw a pill-style tag with rounded edges. */
  pill: boolean;
  /** Set to `true` to make the tag clearable. */
  clearable: boolean;
  /** Emitted when the clear button is activated. */
  flowClear: EventEmitter;
  connectedCallback(): void;
  private handleClearClick;
  render(): any;
}
