import { EventEmitter, ComponentWillLoad } from '../../stencil-public-runtime';
import { FlowCoreContext } from '../../core/public-api';
/**
 * @status stable
 */
export declare class FlowContext implements ComponentWillLoad {
  /**
   * The Flo.w API key for accessing the Flo.w REST API.
   */
  apiKey: string;
  /**
   * @internal
   *
   * READ ONLY! The initialized Flo.w context.
   */
  context: FlowCoreContext;
  /**
   * The Flo.w context ID. Specify to use multiple contexts.
   */
  contextId: string;
  /**
   * The Flo.w host URL for accessing the Flo.w REST API.
   */
  host: string;
  /** Emitted when the context is initialized. */
  flowContextInitialized: EventEmitter<FlowCoreContext>;
  componentWillLoad(): void;
  render(): any;
}
