import { ComponentDidLoad, EventEmitter } from '../../stencil-public-runtime';
import { HTMLStencilElement } from '../../stencil-public-runtime';
/**
 * @since 1.0
 * @status stable
 * @reactive
 */
export declare class FlowValue implements ComponentDidLoad {
  private initialized;
  private context;
  private autorunDisposer;
  private internalValue;
  private numberFormatter;
  el: HTMLStencilElement;
  /**
   * Specifies the transition duration in milliseconds for the animation between numeric values. Set
   * to zero to disable animation.
   */
  duration: number;
  /**
   * The Flo.w context ID to use for application state.
   */
  flowContext: string;
  /**
   * Specifies the display format. Use a D3 format string for numeric values. Use `"icon"` to
   * treat `value` as an icon name.
   */
  format: string;
  /**
   * Specifies the value to display as a Flo.w reactive expression.
   * @reactive
   */
  value: string;
  /**
   * Emitted when the value changes.
   */
  flowDataValueChanged: EventEmitter<number | string>;
  connectedCallback(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): Promise<void>;
  connect(): Promise<void>;
  disconnect(): Promise<void>;
  private updateNumberFormatter;
  private subscribe;
  private unsubscribe;
  private setValue;
  private formatValue;
  render(): any;
}
