import { EventEmitter, ComponentWillLoad, ComponentDidLoad } from '../../../stencil-public-runtime';
/**
 * @since 1.0
 * @status stable
 *
 * @slot - The main body content of drawer.
 * @slot header - The drawer header content.
 * @slot footer - The drawer footer content.
 *
 * @part drawer - The drawer container.
 */
export declare class FlowDrawer implements ComponentWillLoad, ComponentDidLoad {
  private initialized;
  private drawerEl;
  private drawer;
  private hasHeader;
  private hasFooter;
  el: HTMLElement;
  /**
   * Set to `true` to open the drawer.
   */
  open: boolean;
  private updateOpen;
  /**
   * The side of the parent element to which the drawer is attached.
   */
  position: 'start' | 'end';
  /**
   * Set to `true` to display a 'side tab', which can be used to toggle the open state of the drawer.
   */
  sideTab: boolean;
  /**
   * Emitted when the drawer is opening.
   */
  drawerOpening: EventEmitter;
  /**
   * Emitted when the drawer is closing.
   */
  drawerClosing: EventEmitter;
  /**
   * Emitted when the drawer has opened.
   */
  drawerOpened: EventEmitter;
  /**
   * Emitted when the drawer has closed.
   */
  drawerClosed: EventEmitter;
  connectedCallback(): void;
  componentWillLoad(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  connect(): void;
  disconnect(): void;
  render(): any;
  openHandler: (ev: any) => void;
  closeHandler: (ev: any) => void;
}
