import { ComponentDidLoad } from '../../../stencil-public-runtime';
import { PredefinedColor } from '../../../utils/theme';
/**
 * @since 1.0
 * @status stable
 */
export declare class FlowFabButton implements ComponentDidLoad {
  private initialized;
  private ripple;
  private button;
  /**
   * The color of the FAB. Colors are taken from the application palette.
   */
  color?: PredefinedColor;
  /**
   * Set to `true` to display a smaller FAB.
   */
  compact: boolean;
  /**
   * Set to display an icon on the button. The property can be the name of
   * a built-in icon, a URL of an SVG file, or an SVG data URI.
   */
  icon?: string;
  /**
   * Set to add an optional label to the FAB.
   */
  label?: string;
  /**
   * Set to `true` to display the FAB using the 'square' style. By default,
   * FABs are round.
   */
  square: boolean;
  /**
   * Set to `true` for the FAB to act like a checkbox.
   */
  checkbox: boolean;
  /**
   * The checked state of the FAB. Only applicable if `checkbox` is set to `true`.
   */
  checked: boolean;
  /**
   * The value attribute of the FAB. Only applicable if `checkbox` is set to `true`.
   */
  value?: string;
  constructor();
  connectedCallback(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  connect(): void;
  disconnect(): void;
  private handleClick;
  render(): any;
}
