import { PredefinedColor } from '../../utils/theme';
/**
 * @since 1.0
 * @status stable
 */
export declare class FlowIcon {
  private io?;
  el: HTMLFlowIconElement;
  private svgContent?;
  private isVisible;
  /**
   * Specifies the label to use for accessibility. Defaults to the icon name.
   */
  ariaLabel: string | null;
  /**
   * The color of the gauge value. Colors are taken from the application palette.
   * If unset, the current color will be used.
   */
  color?: PredefinedColor;
  /**
   * The name of a built-in icon or URL to an SVG file.
   */
  icon?: any;
  /**
   * The size of the icon. If not specified, the current font-size will be used.
   */
  size?: 'x-small' | 'small' | 'regular' | 'large' | 'x-large';
  /**
   * If enabled, the icon will be loaded lazily when it is visible in the viewport.
   */
  lazy: boolean;
  connectedCallback(): void;
  disconnectedCallback(): void;
  private waitUntilVisible;
  private loadIcon;
  render(): any;
}
