import { ComponentWillLoad, ComponentDidLoad } from '../../../stencil-public-runtime';
import { PredefinedColor } from '../../../utils/theme';
/**
 * @since 1.0
 * @status stable
 *
 * @slot - The content of the header.
 */
export declare class FlowListHeader implements ComponentWillLoad, ComponentDidLoad {
  private boundTransitionHandler;
  el: HTMLElement;
  /**
   * The color of list header text and optional icon. Colors are taken from the application palette.
   */
  color?: PredefinedColor;
  /**
   * Set to display an icon before the title of the header. The property can be the name of
   * a built-in icon, a URL to an SVG file, or an SVG data URI.
   */
  icon: string;
  /**
   * Set to `true` to display an expand/collapse button and make the following `flow-list`
   * collapsible.
   */
  collapsible: boolean;
  /**
   * Set to open or close the following `flow-list`. Only applicable if `collapsible` is `true`.
   */
  open: boolean;
  updateOpen(): Promise<void>;
  componentWillLoad(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  private transitionHandler;
  private getList;
  render(): any;
}
