import { HTMLStencilElement } from '../../../stencil-public-runtime';
import { FlowCoreDataJoin } from '../../../core/flow-core-map/flow-core-data-join';
/**
 * @since 1.0
 * @status stable
 *
 * @reactive
 */
export declare class FlowMapDataJoin {
  private mutationObserver;
  el: HTMLStencilElement;
  flowMapDataSource: HTMLFlowMapDataSourceElement;
  flowMap: HTMLFlowMapElement;
  /** @internal */
  _datajoin: FlowCoreDataJoin;
  /**
   * The name of the data join.
   *
   * @deprecated Use `id` attribute instead.
   */
  name: string;
  /** The foreign key property of the joined data. Data will be joined to features
   * where the foreign key equals the feature ID.
   */
  foreignKey: string;
  /**
   * Set to `true` to clear all current feature state before applying the data join.
   */
  clear: boolean;
  /**
   * Specify the source layer in the target data source to join. Applicable only for vector data sources.
   * Defaults to 'geometry'.
   */
  sourceLayer?: string;
  /**
   * The data to join. Specify a reactive expression or an array of data objects.
   *
   * @reactive
   */
  src: string | any[];
  private updateSrc;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): Promise<void>;
  private setDataJoinParameters;
  render(): any;
}
