import { ComponentDidLoad, ComponentWillLoad } from '../../../stencil-public-runtime';
import { HTMLStencilElement } from '../../../stencil-public-runtime';
/**
 * @since 1.0
 * @status stable
 */
export declare class MapIcon implements ComponentWillLoad, ComponentDidLoad {
  private initialized;
  private context;
  el: HTMLStencilElement;
  flowMap: HTMLFlowMapElement;
  /**
   * The unique ID of the icon.
   *
   * @deprecated Use ID attribute instead.
   */
  name: string;
  /** The URL of a png or svg icon file. */
  src: string;
  /** The display width in pixels of the icon. */
  width: number;
  /** The display height in pixels of the icon. */
  height: number;
  /** Set to `true` to allow recoloring of icon using map layer style properties. */
  recolor: boolean;
  /**
   * The Flo.w context ID to use for application state.
   */
  flowContext: string;
  /**
   * The pixel density of the icon. To improve display quality on high resolution screens,
   * map icons should be provided at 2x resolution and the default pixelDensity of 2 should
   * be used.
   */
  pixelDensity: number;
  connectedCallback(): Promise<void>;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): void;
  connect(): void;
  disconnect(): void;
  render(): any;
  private imageId;
}
