import { HTMLStencilElement } from '../../../stencil-public-runtime';
import { FlowCoreParameter } from '../../../core/flow-core-map/flow-core-parameter';
/**
 * @since 1.0
 * @status stable
 *
 * @reactive
 */
export declare class FlowMapParameter {
  /** @internal */
  _parameter: FlowCoreParameter;
  /**
   * The parameter name.
   */
  name: string;
  /**
   * The parameter value. A Flo.w reactive expression.
   *
   * @reactive
   */
  value: string;
  /**
   * Set to `true` to disable data joining if this parameter is `null`.
   */
  required: boolean;
  el: HTMLStencilElement;
  flowMap: HTMLFlowMapElement;
  componentWillLoad(): Promise<void>;
  private setValue;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): Promise<void>;
  render(): any;
}
