import { ComponentDidLoad, ComponentWillLoad } from '../../../stencil-public-runtime';
import { HTMLStencilElement } from '../../../stencil-public-runtime';
/**
 * @sing 1.0
 * @status stable
 *
 * @slot - The popup content.
 */
export declare class FlowMapPopup implements ComponentWillLoad, ComponentDidLoad {
  el: HTMLStencilElement;
  flowMap: HTMLFlowMapElement;
  /**
   * The unique popup ID.
   *
   * @deprecated Use `id` attribute instead.
   */
  name: string;
  /**
   * Set to `true` to enable 'close' button.
   */
  closeButton: boolean;
  /**
   * Set to `true` to close popup when map is clicked.
   */
  closeOnClick: boolean;
  /**
   * Set to `true` to close popup when map is moved.
   */
  closeOnMove: boolean;
  /** Maximum width of popup in CSS units. */
  maxWidth: string;
  /**
   *
   * Move popup when feature location changes. Specify `true` to enable
   * automatic location tracking as map feature moves or specify a
   * reactive expression returning lng/lat as a 2-element array.
   *
   * @reactive
   */
  trackLocation?: string | boolean;
  /** Move popup to `trackLocation` immediately. */
  fireTrackImmediately: boolean;
  /** Specify a CSS class to add to the popup. */
  popupClass?: string;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): Promise<void>;
  render(): any;
}
