import { ComponentDidLoad } from '../../stencil-public-runtime';
import { PredefinedColor } from '../../utils/theme';
/**
 * @since 1.1
 * @status stable
 */
export declare class ProgressRing implements ComponentDidLoad {
  private mdcProgress;
  private mdcProgressEl;
  width: number;
  radius: number;
  circum: number;
  strokeWidth: number;
  /**
   * The color of the progress indicator. Colors are taken from the application palette.
   */
  color?: PredefinedColor;
  /**
   * Set to `true` to show an indeterminate circular progress indicator.
   */
  indeterminate: boolean;
  /**
   * Set to `true` to automatically show the progress indicator when progress is between 0 and 1.
   */
  autoShow: boolean;
  /**
   * Specify the size of the circular progress indicator.
   */
  size: 'small' | 'medium' | 'large' | 'x-large' | 'xx-large';
  updateSize(): void;
  /**
   * Set to a value between 0 and 1 to indicate current progress.
   */
  value: number;
  updateProgress(): void;
  componentWillLoad(): void;
  componentDidLoad(): void;
  private renderDeterminateContainer;
  private renderIndeterminateContainer;
  render(): any;
}
