/**
 * @since 2.0
 * @status stable
 *
 * @slot - The tab's label.
 */
export declare class Tab {
  componentId: string;
  tab: HTMLElement;
  host: HTMLFlowTabElement;
  /** The name of the tab panel the tab will control. The panel must be located in the same tab group. */
  panel: string;
  /** Set to true to draw the tab in an active state. */
  active: boolean;
  /** Set to true to draw the tab in a disabled state. */
  disabled: boolean;
  /** Set focus to the tab. */
  setFocus(): Promise<void>;
  /** Remove focus from the tab. */
  removeFocus(): Promise<void>;
  render(): any;
}
