/**
 * @internal
 *
 * Like computed, except that after creation, subsequent re-evaluations
 * are throttled to occur at the specified minimum interval.
 *
 * @param compute The function to evaluate in reaction
 * @param delay The minimum delay between evaluations
 * @param name (optional) For MobX debug purposes
 */
export declare function throttledComputed<T>(compute: () => T, delay: number, name?: string): {
  get(): T;
  refresh(): void;
};
