import { CompositeLayerSpecification } from './composite-layer/composite-layer-style';
import { FlowCoreDataSource } from './flow-core-data-source';
import { FlowCoreMapLayer } from './flow-core-map-layer';
import { FlowCoreMapLayerBase, FlowCoreMapLayerOptions } from './flow-core-map-layer-base';
/**
 * Core functionality for Flo.w map layers. Wrapped by the `<flow-map-layer>` web component.
 *
 * @noInheritDoc
 */
export declare class FlowCoreMapCompositeLayer implements FlowCoreMapLayerBase {
  private source;
  private parsedStyle;
  private parsedFilter;
  id: string;
  minZoom: number;
  maxZoom: number;
  layers: FlowCoreMapLayer[];
  datasources: FlowCoreDataSource[];
  readonly options: FlowCoreMapLayerOptions;
  /**
   * Constructs a new `FlowCoreMapLayer` instance.
   *
   * @param options Map layer options.
   */
  constructor(options: FlowCoreMapLayerOptions);
  get maplibreStyleSpecification(): {
    datasources: {};
    layers: any[];
  };
  setSource(source: string | CompositeLayerSpecification): void;
  setStyle(style: string): void;
  setFilter(filter: string): void;
  /**
   * Creates sub-layers and data sources from the composite layer specification.
   */
  private createSubLayers;
}
export declare function isCompositeLayer(layer: FlowCoreMapLayerBase): layer is FlowCoreMapCompositeLayer;
