export declare class MapLayerStyleBuilder {
  private static _styleBuilders;
  static registerStyleBuilder(layerType: string, builder: typeof MapLayerStyleBuilder): void;
  static createStyleBuilder(layerType: string): MapLayerStyleBuilder;
  private _styles;
  /**
   * Whether this layer is displayed.
   *
   * @param value - visible value (default `true`)
   */
  visibility(value: boolean): this;
  /**
   * Create a style specification string.
   *
   * Call this method after setting all style properties
   * on the style builder.
   *
   * @returns Layer style specification string
   */
  build(): string;
  /**
   * Format and add style property to the style builder.
   */
  protected addStyle(property: string, value: unknown): void;
  private formatValue;
}
export declare class StyleExpression {
  private _expr;
  constructor(_expr: string);
  toString(): string;
}
export declare function expr(expr: string): StyleExpression;
