/**
 * @internal
 */
export declare type LayerType = 'fill' | 'line' | 'symbol' | 'circle' | 'heatmap' | 'fill-extrusion' | 'raster' | 'hillshade' | 'background';
/**
* @internal
*/
export declare type PropertyType = 'layout' | 'paint';
/**
 * @internal
 */
export interface PropertyMetadata {
  propertyKey: string;
  mapboxProperty: string;
  type: PropertyType;
  definition: any;
}
/**
 * @internal
 */
export declare class MaplibreGLSpecHelper {
  private static _instance;
  private layerTypes;
  private propertyIndex;
  static get instance(): MaplibreGLSpecHelper;
  private constructor();
  getPropertyMetadata(propertyKey: string, layerType: LayerType): PropertyMetadata;
  getPropertyType(propertyKey: string, layerType: LayerType): PropertyType;
  evaluateExpression(expr: any): any;
  /**
   * Construct index of layer properties by layer type
   */
  private initializePropertyIndex;
}
