# Flo.w RDF JavaScript API

Use the JavaScript API to work with Flo.w RDF reactive data. [FlowCoreContext](./classes/flowcorecontext.md) is the entry point to the API and every Flo.w application should instantiate a global context instance.

From the global context, you can navigate to Flo.w RDF functionality, such as application state management and registries for maps and chart specifications.

See [Using Flo.w RDF](../using/0-overview.md) for details of how to initialize a context instance and access the Flo.w RDF JavaScript API in your project.

## Key Classes

- [FlowCoreContext](./classes/flowcorecontext.md) - The entry point to the JavaScript API.
- [StateStore](./classes/statestore.md) - Application state management.
- [ChartSpecRegistry](./classes/chartspecregistry.md) - Register and retrieve chart specifications.
- [MapRegistry](./classes/mapregistry.md) - Register and retrieve maps.
- [FlowCoreMap](./classes/flowcoremap.md) - Core map functionality.

:::warning
Low-level classes are available for working with maps and charts. These are used internally by Flo.w RDF Web Components.

These classes may be used to integrate Flo.w RDF functionality directly with frameworks (or in environments where Web Components are not supported). However, we recommend using Flo.w Web Components where possible.
:::
